/**********************************************************************
 *    Copyright Torquil Gault 2005+
 * #       This program is free software; you can redistribute it and/or
 * #       modify it under the terms of the GNU General Public License
 * #       as published by the Free Software Foundation; either version 2
 * #       of the License, or (at your option) any later version.
 * #
 * #       This program is distributed in the hope that it will be useful,
 * #       but WITHOUT ANY WARRANTY; without even the implied warranty of
 * #       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * #       GNU General Public License for more details.
 * #
 * #       You should have received a copy of the GNU General Public License
 * #       along with this program; if not, write to the Free Software
 * #       Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * #
 * #
 * ###############################################################################
 **********************************************************************/
// ********************************************************************************
#include <stdio.h>
#include <string.h>
#ifndef VISUALC
#include <strings.h>
#endif
#include <ctype.h>

#include <FL/Fl.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Browser.H>
#include <FL/Fl_Text_Editor.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Round_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Check_Browser.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Tile.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Counter.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Help_View.H>
#include <FL/Fl_Text_Editor.H>
#include <FL/Fl_Text_Buffer.H>

#include "ADMPdata.h"
#include "ADMPexternals.h"

// ********************************************************************************
extern ADMPsystem config;
extern ADMPplayer  players[MAX_MEMBERS+2], qkmonsters[MAX_QKMONSTERS+2];

extern Fl_Text_Buffer *treasure_buffer[2];

// ********************************************************************************
unsigned char rndTreasureTbl[20][4] = {
	{1,34,35,36},
	{2,40,41,42},
	{3,43,44,45},
	{4,46,47,48},
	{5,49,50,51},
	{6,52,53,54},
	{7,55,56,57},
	{8,58,59,60},
	{9,61,62,63},
	{10,4,5,6},
	{11,7,8,9},
	{12,10,11,12},
	{13,13,14,15},
	{14,16,17,18},
	{15,19,20,21},
	{16,22,23,24},
	{17,25,26,27},
	{18,28,29,30},
	{19,31,32,33},
	{20,37,38,39}};

// ********************************************************************************
//typedef struct treasureTblData {
//	unsigned char table_id, start_roll, end_roll;
//	char *data;
//} treasureTblData;

treasureTblData rndTreasureTblData[] = {
{34,1,14, "Nothing"},
{34,15,29, "cp|1d6 x 1000"},
{34,30,52, "sp|1d8 x 100"},
{34,53,95, "gp|2d8 x 10"},
{34,96,100, "pp|1d4 x 10"},
{40,1,13, "Nothing"},
{40,14,23, "cp|1d10 x 1000"},
{40,24,43, "sp|2d10 x 100"},
{40,44,95, "gp|4d10 x 10"},
{40,96,100, "pp|2d8 x 10"},
{43,1,11, "Nothing"},
{43,12,21, "cp|2d10 x 1000"},
{43,22,41, "sp|4d8 x 100"},
{43,42,95, "gp|1d4 x 100"},
{43,96,100, "pp|1d10 x 10"},
{46,1,11, "Nothing"},
{46,12,21, "cp|3d10 x 1000"},
{46,22,41, "sp|4d12 x 1000"},
{46,42,95, "gp|1d6 x 100"},
{46,96,100, "pp|1d8 x 10"},
{49,1,10, "Nothing"},
{49,11,19, "cp|1d4 x 10000"},
{49,20,38, "sp|1d6 x 1000"},
{49,39,95, "gp|1d8 x 100"},
{49,96,100, "pp|1d10 x 10"},
{52,1,11, "Nothing"},
{52,12,18, "cp|1d6 x 10000"},
{52,19,37, "sp|1d8 x 1000"},
{52,38,95, "gp|1d10 x 100"},
{52,96,100, "pp|1d12 x 10"},
{55,1,11, "Nothing"},
{55,12,18, "cp|1d10 x 10000"},
{55,19,35, "sp|1d12 x 1000"},
{55,36,93, "gp|2d6 x 100"},
{55,94,100, "pp|3d4 x 10"},
{58,1,10, "Nothing"},
{58,11,15, "cp|1d12 x 10000"},
{58,16,29, "sp|2d12 x 1000"},
{58,30,87, "gp|2d8 x 100"},
{58,88,100, "pp|2d6 x 10"},
{61,1,11, "Nothing"},
{61,12,21, "cp|2d6 x 10000"},
{61,22,41, "sp|2d8 x 1000"},
{61,42,95, "gp|5d4 x 100"},
{61,96,100, "pp|2d12 x 10"},
{4,1,10, "Nothing"},
{4,11,24, "sp|2d10 x 1000"},
{4,25,79, "gp|6d4 x 100"},
{4,80,100, "pp|5d6 x 10"},
{7,1,8, "Nothing"},
{7,9,24, "sp|3d10 x 1000"},
{7,25,79, "gp|4d8 x 100"},
{7,80,100, "pp|4d10 x 10"},
{10,1,8, "Nothing"},
{10,9,14, "sp|3d12 x 1000"},
{10,15,75, "gp|1d4 x 1000"},
{10,76,100, "pp|1d4 x 100"},
{13,1,8, "Nothing"},
{13,9,75, "gp|1d4 x 1000"},
{13,76,100, "pp|1d10 x 100"},
{16,1,8, "Nothing"},
{16,9,75, "gp|1d6 x 1000"},
{16,76,100, "pp|1d12 x 100"},
{19,1,3, "Nothing"},
{19,4,74, "gp|1d8 x 1000"},
{19,75,100, "pp|3d4 x 100"},
{22,1,3, "Nothing"},
{22,4,68, "gp|1d12 x 1000"},
{22,69,100, "pp|3d4 x 100"},
{25,1,3, "Nothing"},
{25,4,68, "gp|3d4 x 1000"},
{25,69,100, "pp|2d10 x 100"},
{28,1,2, "Nothing"},
{28,3,65, "gp|3d6 x 1000"},
{28,66,100, "pp|5d4 x 100"},
{31,1,2, "Nothing"},
{31,3,65, "gp|3d8 x 1000"},
{31,66,100, "pp|3d10 x 100"},
{37,1,2, "Nothing"},
{37,3,65, "gp|4d8 x 1000"},
{37,66,100, "pp|4d10 x 100"},
{35,1,90, "Nothing"},
{35,91,95, "t#64"},
{35,96,100, "t#71"},
{41,1,81, "Nothing"},
{41,82,95, "1d3|t#64"},
{41,96,100, "1d3|t#71"},
{44,1,77, "Nothing"},
{44,78,95, "1d3|t#64"},
{44,96,100, "1d3|t#71"},
{47,1,70, "Nothing"},
{47,71,95, "1d4|t#64"},
{47,96,100, "1d3|t#71"},
{50,1,60, "Nothing"},
{50,61,95, "1d4|t#64"},
{50,96,100, "1d4|t#71"},
{53,1,56, "Nothing"},
{53,57,92, "1d4|t#64"},
{53,93,100, "1d4|t#71"},
{56,1,48, "Nothing"},
{56,49,88, "1d4|t#64"},
{56,89,100, "1d4|t#71"},
{59,1,45, "Nothing"},
{59,46,85, "1d6|t#64"},
{59,86,100, "1d4|t#71"},
{62,1,40, "Nothing"},
{62,41,80, "1d8|t#64"},
{62,81,100, "1d4|t#71"},
{5,1,35, "Nothing"},
{5,36,79, "1d8|t#64"},
{5,80,100, "1d6|t#71"},
{8,1,24, "Nothing"},
{8,25,74, "1d10|t#64"},
{8,75,100, "1d6|t#71"},
{11,1,17, "Nothing"},
{11,18,70, "1d10|t#64"},
{11,71,100, "1d8|t#71"},
{14,1,11, "Nothing"},
{14,12,66, "1d12|t#64"},
{14,67,100, "1d10|t#71"},
{17,1,11, "Nothing"},
{17,12,66, "2d8|t#64"},
{17,67,100, "2d6|t#71"},
{20,1,9, "Nothing"},
{20,10,65, "2d10|t#64"},
{20,66,100, "2d8|t#71"},
{23,1,7, "Nothing"},
{23,8,64, "4d6|t#64"},
{23,65,100, "2d10|t#71"},
{26,1,4, "Nothing"},
{26,5,63, "4d8|t#64"},
{26,64,100, "3d8|t#71"},
{29,1,4, "Nothing"},
{29,5,54, "3d12|t#64"},
{29,55,100, "3d10|t#71"},
{32,1,3, "Nothing"},
{32,4,50, "6d6|t#64"},
{32,51,100, "6d6|t#71"},
{38,1,2, "Nothing"},
{38,3,38, "4d10|t#64"},
{38,39,100, "7d6|t#71"},
{36,1,71, "Nothing"},
{36,72,95, "t#84"},
{36,96,100, "t#116"},
{42,1,49, "Nothing"},
{42,50,85, "t#84"},
{42,86,100, "t#116"},
{45,1,49, "Nothing"},
{45,50,79, "1d3|t#84"},
{45,80,100, "t#116"},
{48,1,42, "Nothing"},
{48,43,62, "1d4|t#84"},
{48,63,100, "t#116"},
{51,1,57, "Nothing"},
{51,58,67, "1d4|t#84"},
{51,68,100, "1d3|t#116"},
{54,1,54, "Nothing"},
{54,55,59, "1d4|t#84"},
{54,60,99, "1d3|t#116"},
{54,100,100, "1d3|t#115"},
{57,1,51, "Nothing"},
{57,52,97, "1d3|t#116"},
{57,98,100, "1d3|t#115"},
{60,1,48, "Nothing"},
{60,49,96, "1d4|t#116"},
{60,97,100, "1d3|t#115"},
{63,1,43, "Nothing"},
{63,44,91, "1d4|t#116"},
{63,92,100, "1d3|t#115"},
{6,1,40, "Nothing"},
{6,41,88, "1d4|t#116"},
{6,89,99, "t#115"},
{6,100,100, "t#114"},
{9,1,31, "Nothing"},
{9,32,84, "1d4|t#116"},
{9,85,98, "t#115"},
{9,99,100, "t#114"},
{12,1,27, "Nothing"},
{12,28,82, "1d6|t#116"},
{12,83,97, "t#115"},
{12,98,100, "t#114"},
{15,1,19, "Nothing"},
{15,20,73, "1d6|t#116"},
{15,74,95, "t#115"},
{15,96,100, "t#114"},
{18,1,19, "Nothing"},
{18,20,58, "1d6|t#116"},
{18,59,92, "t#115"},
{18,93,100, "t#114"},
{21,1,11, "Nothing"},
{21,12,46, "1d10|t#116"},
{21,47,90, "t#115"},
{21,91,100, "t#114"},
{24,1,40, "Nothing"},
{24,41,46, "1d10|t#116"},
{24,47,90, "1d3|t#115"},
{24,91,100, "t#114"},
{27,1,33, "Nothing"},
{27,34,83, "1d3|t#115"},
{27,84,100, "t#114"},
{30,1,24, "Nothing"},
{30,25,80, "1d4|t#115"},
{30,81,100, "t#114"},
{33,1,4, "Nothing"},
{33,5,70, "1d4|t#115"},
{33,71,100, "t#114"},
{39,1,25, "Nothing"},
{39,26,65, "1d4|t#115"},
{39,66,100, "1d3|t#114"},
{64,1,25, "4d4 x 1|Gems|t#66"},
{64,26,50, "2d4 x 10|Gems|t#67"},
{64,51,70, "4d4 x 10|Gems|t#68"},
{64,71,90, "2d4 x 100|Gems|t#69"},
{64,91,99, "4d4 x 100|Gems|t#70"},
{64,100,100, "2d4 x 1000|Gems|t#65"},
{66,1,8, "banded agate"},
{66,9,16, "eye agate"},
{66,17,24, "moss agate"},
{66,25,32, "azurit"},
{66,33,40, "blue quartz"},
{66,41,48, "hematite"},
{66,49,56, "lapis lazuli"},
{66,57,64, "malachite"},
{66,65,73, "obsidian"},
{66,74,82, "rhodochrosite"},
{66,83,91, "turquoise tiger eye"},
{66,92,100, "freshwater pearl"},
{67,1,7, "bloodstone"},
{67,8,14, "carnelian"},
{67,15,21, "chalcedony"},
{67,22,28, "chrysoprase"},
{67,29,34, "jasper"},
{67,35,40, "moonstone"},
{67,41,46, "onyx"},
{67,47,52, "peridot"},
{67,53,58, "rock crystal (clear quartz)"},
{67,59,64, "sard"},
{67,65,70, "sardonyx"},
{67,71,76, "rose quartz"},
{67,77,82, "smoky quartz"},
{67,83,88, "star rose quartz"},
{67,89,94, "zircon"},
{67,95,100, "citrine"},
{68,1,7, "amber"},
{68,8,14, "amethyst"},
{68,15,21, "chrysoberyl"},
{68,22,28, "coral"},
{68,29,34, "red garnet"},
{68,35,40, "brown-green garnet"},
{68,41,46, "jade"},
{68,47,52, "jet"},
{68,53,58, "while pearl"},
{68,59,64, "golden pearl"},
{68,65,70, "pink pearl"},
{68,71,76, "silver pearl"},
{68,77,82, "red spinel"},
{68,83,88, "red-brown spiniel"},
{68,89,94, "deep green spinel"},
{68,95,100, "tourmaline"},
{69,1,16, "alexandrite"},
{69,17,32, "aquamarine"},
{69,33,49, "violet garnet"},
{69,50,66, "black pearl"},
{69,67,83, "deep blue spinel"},
{69,84,100, "golden yellow topaz"},
{70,1,10, "emerald"},
{70,11,20, "while opal"},
{70,21,30, "black opal"},
{70,31,40, "fire opal"},
{70,41,50, "blue sapphire"},
{70,51,60, "fiery yellow corundum"},
{70,61,70, "rich purple corundum"},
{70,71,80, "blue star sapphire"},
{70,81,90, "black star sapphire"},
{70,91,100, "star ruby"},
{65,1,15, "clearest bright green emerald"},
{65,16,30, "blue whyte diamond"},
{65,31,44, "canary diamond"},
{65,45,58, "pink diamond"},
{65,59,72, "brown diamond"},
{65,73,86, "blue diamond"},
{65,87,100, "jacinth"},
{71,1,10, "1d10 x 10|Art objects|t#72"},
{71,11,25, "3d6 x 10|Art objects|t#74"},
{71,26,40, "1d6 x 100|Art objects|t#75"},
{71,41,50, "1d10 x 100|Art objects|t#76"},
{71,51,60, "2d6 x 100|Art objects|t#77"},
{71,61,70, "3d6 x 100|Art objects|t#78"},
{71,71,80, "4d6 x 100|Art objects|t#79"},
{71,81,85, "5d6 x 100|Art objects|t#80"},
{71,86,90, "1d4 x 1000|Art objects|t#81"},
{71,91,95, "1d6 x 1000|Art objects|t#82"},
{71,96,99, "2d4 x 1000|Art objects|t#83"},
{71,100,100, "2d6 x 1000|Art objects|t#720"},
{72,1,25, "silver ever"},
{72,26,50, "carved bone statuette"},
{72,51,75, "ivory statuette"},
{72,76,100, "finely wrought small gold bracelet"},
{74,1,33, "cloth of gold vestments"},
{74,34,66, "black velvet mask with numerous citrines"},
{74,67,100, "silver chalice with lapis lazuli gems"},
{75,1,50, "large well-done wool tapestry"},
{75,51,100, "brass mug with jade inlays"},
{76,1,50, "silver comb with moonstones"},
{76,51,100, "silver-plated steel longsword with jet jewel in hilt"},
{77,1,50, "carvet harp of excotic wood with ivory inlay and zircon gems"},
{77,51,100, "solid gold idol (10 lb.)"},
{78,1,33, "gold dragon comb with red garnet eye"},
{78,34,66, "gold and topaz bottle stopper cork"},
{78,67,100, "ceremonial electrum dagger with a star ruby in the pommel"},
{79,1,33, "eyepath with mock eye of sapphire and moonstone"},
{79,34,66, "fire opal pendant on a fine gold chain"},
{79,67,100, "old masterpiece painting"},
{80,1,50, "embroidered silk and velvet mantle with numerous moonstones"},
{80,51,100, "sapphire pendant on gold chain"},
{81,1,33, "embroidered and bejeweled glove"},
{81,34,66, "jeweled anklet"},
{81,67,100, "gold music box"},
{82,1,50, "golden circlet with four aquamarines"},
{82,51,100, "a string of small pink pearls (necklace)"},
{83,1,50, "jeweled gold crown"},
{83,51,100, "jeweled electrum ring"},
{72,1,50, "gold and ruby ring"},
{72,51,100, "gold cup set with emeralds"},
{84,1,17, "Mundane items|Alchemical item|t#85"},
{84,18,50, "Mundane items|Armor|t#86"},
{84,51,83, "Mundane items|Weapon|t#90"},
{84,84,100, "Mundane items|Tools and gear|t#89"},
{85,1,12, "alchemist's fire|20|1d4"},
{85,13,24, "acid|10|2d4"},
{85,25,36, "smokesticks|20|1d4"},
{85,37,48, "holy water|25|1d4"},
{85,49,62, "antitoxin|50|1d4"},
{85,63,74, "everburning torch|1"},
{85,75,88, "tanglefoot bags|50|1d4"},
{85,89,100, "thunderstones|30|1d4"},
{86,1,12, "chain shirt|100|t#3"},
{86,13,18, "masterwork studded leather|175|t#3"},
{86,19,26, "breastplate|200|t#3"},
{86,27,34, "banded mail|200|t#3"},
{86,35,54, "half-plate|600|t#3"},
{86,55,80, "full-plate|1500|t#3"},
{86,81,90, "darkwood|t#87"},
{86,91,100, "masterwork_shield|t#88"},
{87,1,50, "buckler|darkwood|205|t#3"},
{87,51,100, "darkwood|shield|257|t#3"},
{88,1,17, "buckler|masterwork|165|t#3"},
{88,18,40, "masterwork|light wooden shield|153|t#3"},
{88,41,60, "masterwork|light steel shield|159|t#3"},
{88,61,83, "masterwork|heavy wooden shield|157|t#3"},
{88,84,100, "masterwork|heavy steel shield|170|t#3"},
{90,1,50, "masterwork|t#92"},
{90,51,70, "masterwork|t#93"},
{90,71,100, "masterwork|t#94"},
{89,1,3, "empty backpack|2"},
{89,4,6, "crowbar|2"},
{89,7,11, "bullseye latern|12"},
{89,12,16, "simple lock|20"},
{89,17,21, "average lock|40"},
{89,22,28, "good lock|80"},
{89,29,35, "superior lock|150"},
{89,36,40, "masterwork manacles|50"},
{89,41,43, "small steel mirror|10"},
{89,44,46, "50 ft. silk rope|10"},
{89,47,53, "spyglass|1000"},
{89,54,58, "masterwork artisan's tools|55"},
{89,59,63, "climber's kit|80"},
{89,64,68, "disguise kit|50"},
{89,69,73, "healer's kit|50"},
{89,74,77, "holy silver symbol|25"},
{89,78,81, "hourglass|25"},
{89,82,88, "magnifying glass|100"},
{89,89,95, "masterwork musical instrument|100"},
{89,96,100, "masterwork thieves' tools|50"},
{116,1,4, "Armor and Shields|Minor magic items|t#156"},
{116,5,9, "Minor magic items|Weapons|t#173"},
{116,10,44, "Minor magic items|Potions and Oils|t#107"},
{116,45,46, "Minor magic items|Rings|t#110"},
{116,47,81, "Minor magic items|Scrolls|t#117|t#120"},
{116,82,91, "Minor magic items|Wands|1d50|t#149|t#150"},
{116,92,100, "Minor magic items|Wondrous items|t#151"},
{115,1,10, "Medium magic items|Armor and Shields|t#155"},
{115,11,20, "Medium magic items|Weapons|t#172"},
{115,21,30, "Medium magic items|Potions and Oils|t#106"},
{115,31,40, "Medium magic items|Rings|t#109"},
{115,41,50, "Medium magic items|Rods|t#112|t#113"},
{115,51,65, "Medium magic items|Scrolls|t#117|t#119"},
{115,66,68, "Medium magic items|Staffs|1d50|t#146|t#144"},
{115,69,83, "Medium magic items|Wands|1d50|t#148|t#150"},
{115,84,100, "Medium magic items|Wondrous items|t#152"},
{114,1,10, "Major magic items|Armor and Shields|t#154"},
{114,11,20, "Major magic items|Weapons|t#171"},
{114,21,25, "Major magic items|Potions and Oils|t#105"},
{114,26,35, "Major magic items|Rings|t#108"},
{114,36,45, "Major magic items|Rods|t#111|t#113"},
{114,46,55, "Major magic items|Scrolls|t#117|t#118"},
{114,56,75, "Major magic items|Staffs|1d50|t#145|t#144"},
{114,76,80, "Major magic items|Wands|1d50|t#147|t#150"},
{114,81,100, "Major magic items|Wondrous items|t#153"},
{156,1,60, "1|normal|shield|t#158"},
{156,61,80, "1|normal|armor|t#157"},
{156,81,85, "2|normal|shield|t#158"},
{156,86,87, "2|normal|armor|t#157"},
{156,88,89, "specific|armor|t#167"},
{156,90,91, "specific|shield|t#170"},
{156,92,100, "normal|t#156|t#161|armor|t#164|shield"},
{155,1,5, "1|normal|shield|t#158"},
{155,6,10, "1|normal|armor|t#157"},
{155,11,20, "2|normal|shield|t#158"},
{155,21,30, "2|normal|armor|t#157"},
{155,31,40, "3|normal|shield|t#158"},
{155,41,50, "3|normal|armor|t#157"},
{155,51,55, "4|normal|shield|t#158"},
{155,56,57, "4|normal|armor|t#157"},
{155,58,60, "specific|armor|t#166"},
{155,61,63, "specific|shield|t#169"},
{155,64,100, "normal|t#155|t#160|armor|t#163|shield"},
{154,1,8, "3|normal|shield|t#158"},
{154,9,16, "3|normal|armor|t#157"},
{154,17,27, "4|normal|shield|t#158"},
{154,28,38, "4|normal|armor|t#157"},
{154,39,49, "5|normal|shield|t#158"},
{154,50,57, "5|normal|armor|t#157"},
{154,58,60, "specific|armor|t#165"},
{154,61,63, "normal|shield|t#168"},
{154,64,100, "normal|t#155|t#159|armor|t#162|shield"},
{157,1,1, "Padded|155|t#157|t#3"},
{157,2,2, "Leather|160|t#157|t#3"},
{157,3,17, "Studded leather|175|t#157|t#3"},
{157,18,32, "Chain shirt|250|t#157|t#3"},
{157,33,42, "Hide|165|t#157|t#3"},
{157,43,43, "Scale mail|200|t#157|t#3"},
{157,44,55, "Chainmail|300|t#157|t#3"},
{157,56,57, "Breastplate|350|t#157|t#3"},
{157,58,58, "Splint mail|350|t#157|t#3"},
{157,59,59, "Banded mail|400|t#157|t#3"},
{157,60,60, "Half-plate|750|t#157|t#3"},
{157,61,100, "Full plate|1650|t#157|t#3"},
{158,1,10, "Buckler|165|t#158|t#3"},
{158,11,15, "light Shield|wooden|153|t#158|t#3"},
{158,16,20, "light Shield|159|steel|t#158|t#3"},
{158,21,30, "heavy Shield|157|wooden|t#158|t#3"},
{158,31,95, "heavy Shield|170|steel|t#158|t#3"},
{158,96,100, "tower Shield|180|t#158|t#3"},
{161,1,25, "glamered|2700"},
{161,26,32, "Fortification (light)|1"},
{161,33,52, "Slick (normal)|3750"},
{161,53,72, "Shadow (normal)|3750"},
{161,73,92, "Silent moves (normal)|3750"},
{161,93,96, "spell resistance (13)|2"},
{161,97,97, "Slick (improved)|15000"},
{161,98,98, "Shadow (improved)|15000"},
{161,99,99, "Silent moves (improved)|15000"},
{161,100,100, "t#161|1|t#161"},
{160,1,5, "glamered|2700"},
{160,6,8, "Fortification (light)|1"},
{160,9,11, "Slick (normal)|3750"},
{160,12,14, "Shadow (normal)|3750"},
{160,15,17, "Silent moves (normal)|3750"},
{160,18,19, "spell resistance (13)|2"},
{160,20,29, "Slick (improved)|15000"},
{160,30,39, "Shadow (improved)|15000"},
{160,40,49, "Silent moves (improved)|15000"},
{160,50,54, "Acid resistance (normal)|18000"},
{160,55,59, "Cold resistance (normal)|18000"},
{160,60,64, "Electricity resistance (normal)|18000"},
{160,65,69, "Fire resistance (normal)|18000"},
{160,70,74, "Sonic resistance (normal)|18000"},
{160,75,79, "Ghoust Touch|3"},
{160,80,84, "Invulnerability|3"},
{160,85,89, "Fortification (moderate)|3"},
{160,90,94, "Spell resistance (15)|3"},
{160,95,99, "wild|3"},
{160,100,100, "t#160|1|t#160"},
{159,1,3, "glamered|2700"},
{159,4,4, "Fortification (light)|1"},
{159,5,7, "Slick (improved)|15000"},
{159,8,10, "Shadow (improved)|15000"},
{159,11,13, "Silent moves (improved)|15000"},
{159,14,16, "Acid resistance (normal)|18000"},
{159,17,19, "Cold resistance (normal)|18000"},
{159,20,22, "Electricity resistance (normal)|18000"},
{159,23,25, "Fire resistance (normal)|18000"},
{159,26,28, "Sonic resistance (normal)|18000"},
{159,29,33, "Ghoust Touch|3"},
{159,34,35, "Invulnerability|3"},
{159,36,40, "Fortification (moderate)|3"},
{159,41,42, "Spell resistance (15)|3"},
{159,43,43, "wild|3"},
{159,44,48, "Slick (greater)|33750"},
{159,49,53, "Shadow (greater)|33750"},
{159,54,58, "Silent moves (greater)|33750"},
{159,59,63, "Acid resistance (improved)|42000"},
{159,64,68, "Cold resistance (improved)|42000"},
{159,69,73, "Electricity resistance (improved)|42000"},
{159,74,78, "Fire resistance (improved)|42000"},
{159,79,83, "Sonic resistance (improved)|42000"},
{159,84,88, "Spell resistance (17)|4"},
{159,89,89, "Etherrealness|49000"},
{159,90,90, "Undead controlling|49000"},
{159,91,92, "Fortification (heavy)|5"},
{159,93,94, "Spell resistance (19)|5"},
{159,95,95, "Acid resistance (greater)|66000"},
{159,96,96, "Cold resistance (greater)|66000"},
{159,97,97, "Electricity resistance (greater)|66000"},
{159,98,98, "Fire resistance (greater)|66000"},
{159,99,99, "Sonic resistance (greater)|66000"},
{159,100,100, "t#159|1|t#159"},
{164,1,20, "Arrow catching|1"},
{164,21,40, "bashing|1"},
{164,41,50, "blinding|1"},
{164,51,75, "Fortification (light)|1"},
{164,76,92, "Arrow deflection|2"},
{164,93,97, "animated|2"},
{164,98,99, "spell resistance (13)|2"},
{164,100,100, "t#164|1|t#164"},
{163,1,10, "Arrow catching|1"},
{163,11,20, "bashing|1"},
{163,21,25, "blinding|1"},
{163,26,40, "Fortification (light)|1"},
{163,41,50, "Arrow deflection|2"},
{163,51,57, "animated|2"},
{163,58,59, "spell resistance (13)|2"},
{163,60,63, "Acid resistance (normal)|18000"},
{163,64,67, "Cold resistance (normal)|18000"},
{163,68,71, "Electricity resistance (normal)|18000"},
{163,72,75, "Fire resistance (normal)|18000"},
{163,76,79, "Sonic resistance (normal)|18000"},
{163,80,85, "Ghost touch|3"},
{163,86,95, "Fortification (moderate)|3"},
{163,96,98, "Spell resistance (15)|3"},
{163,99,99, "Wild|3"},
{163,100,100, "t#163|1|t#163"},
{162,1,5, "Arrow catching|1"},
{162,6,8, "bashing|1"},
{162,9,10, "blinding|1"},
{162,11,15, "Fortification (light)|1"},
{162,16,20, "Arrow deflection|2"},
{162,21,25, "animated|2"},
{162,26,28, "Acid resistance (normal)|18000"},
{162,29,31, "Cold resistance (normal)|18000"},
{162,32,34, "Electricity resistance (normal)|18000"},
{162,35,37, "Fire resistance (normal)|18000"},
{162,38,40, "Sonic resistance (normal)|18000"},
{162,41,46, "Ghost touch|3"},
{162,47,56, "Fortification (moderate)|3"},
{162,57,58, "Spell resistance (15)|3"},
{162,59,59, "Wild|3"},
{162,60,64, "Acid resistance (improved)|42000"},
{162,65,69, "Cold resistance (improved)|42000"},
{162,70,74, "Electricity resistance (improved)|42000"},
{162,75,79, "Fire resistance (improved)|42000"},
{162,80,84, "Sonic resistance (improved)|42000"},
{162,85,86, "Spell resistance (17)|4"},
{162,87,87, "Undead controlling|49000"},
{162,88,91, "Fortification (heavy)|5"},
{162,92,93, "Reflecting|5"},
{162,94,94, "Spell resistance (19)|5"},
{162,95,95, "Acid resistance (greater)|66000"},
{162,96,96, "Cold resistance (greater)|66000"},
{162,97,97, "Electricity resistance (greater)|66000"},
{162,98,98, "Fire resistance (greater)|66000"},
{162,99,99, "Sonic resistance (greater)|66000"},
{162,100,100, "t#162|1|t#162"},
{167,1,50, "Mithral shirt|1100|t#3"},
{167,51,80, "Dragonhide plate|3300|t#3"},
{167,81,100, "Elven chain|4150|t#3"},
{166,1,25, "Mithral shirt|1100|t#3"},
{166,26,45, "Dragonhide plate|3300|t#3"},
{166,46,57, "Elven chain|4150|t#3"},
{166,58,67, "Rhino hide|5165|t#3"},
{166,68,82, "Adamantine Breastplate|10200|t#3"},
{166,83,97, "Dwarven plate|16500|t#3"},
{166,98,100, "Banded mail of luck|18900|t#3"},
{165,1,10, "Adamantine Breastplate|10200|t#3"},
{165,11,20, "Dwarven plate|16500|t#3"},
{165,21,32, "Banded mail of luck|18900|t#3"},
{165,33,50, "Celestial armor|22400|t#3"},
{165,51,60, "Plate armor of the deep|24650|t#3"},
{165,61,75, "Breastplate of command|25400|t#3"},
{165,76,90, "Mithral full plate of speed|26500|t#3"},
{165,91,100, "Demon armor|52260|t#3"},
{170,1,30, "Darkwood buckler|205|t#3"},
{170,31,80, "Darkwood shield|257|t#3"},
{170,81,95, "Mithral heavy shield|1020|t#3"},
{170,96,100, "Casters shield|3153|t#3"},
{169,1,20, "Darkwood buckler|205|t#3"},
{169,21,45, "Darkwood shield|257|t#3"},
{169,46,70, "Mithral heavy shield|1020|t#3"},
{169,71,85, "Casters shield|3153|t#3"},
{169,86,90, "Spined shield|5580|t#3"},
{169,91,95, "Lions shield|9170|t#3"},
{169,96,100, "Winged shield|17257|t#3"},
{168,1,20, "Casters shield|3153|t#3"},
{168,21,40, "Spined shield|5580|t#3"},
{168,41,60, "Lions shield|9170|t#3"},
{168,61,90, "Winged shield|17257|t#3"},
{168,91,100, "Absorbing shield|50170|t#3"},
{173,1,70, "1|normal|t#91"},
{173,71,85, "2|normal|t#91"},
{173,86,90, "specific|t#104"},
{173,91,100, "normal|t#173|t#98|melee|t#101|ranged"},
{172,1,10, "1|normal|t#91"},
{172,11,29, "2|normal|t#91"},
{172,30,58, "3|normal|t#91"},
{172,59,62, "4|normal|t#91"},
{172,63,68, "specific|t#103"},
{172,69,100, "normal|t#172|t#97|melee|t#100|ranged"},
{171,1,20, "3|normal|t#91"},
{171,21,38, "4|normal|t#91"},
{171,39,49, "5|normal|t#91"},
{171,50,63, "specific|t#102"},
{171,64,100, "normal|t#171|t#96|melee|t#99|ranged"},
{91,1,70, "melee|melee|t#92"},
{91,71,80, "melee|melee|t#93"},
{91,81,100, "ranged|ranged|t#94"},
{92,1,4, "Dagger|302|piercing|slashing|thrown|t#3"},
{92,5,14, "Greataxe|320|slashing|t#3"},
{92,15,24, "Greatsword|350|slashing|t#3"},
{92,25,28, "Kama|302|slashing|t#3"},
{92,29,41, "Longsword|315|slashing|t#3"},
{92,42,45, "light Mace|305|bludgeoning|t#3"},
{92,46,50, "heavy Mace|312|bludgeoning|t#3"},
{92,51,54, "Nunchaku|302|bludgeoning|t#3"},
{92,55,57, "Quarterstaff|600|bludgeoning|t#3|t#2"},
{92,58,61, "Rapier|320|piercing|t#3"},
{92,62,66, "Scimitar|315|slashing|t#3"},
{92,67,70, "Shortspear|302|piercing|thrown|t#3"},
{92,71,74, "Siangham|303|piercing|t#3"},
{92,75,84, "bastard Sword|335|slashing|t#3"},
{92,85,89, "short Sword|310|piercing|t#3"},
{92,90,100, "dwarfen Waraxe|330|slashing|t#3"},
{93,1,3, "orc double Axe|660|slashing|t#3|t#2"},
{93,4,7, "Battleaxe|310|slashing|t#3"},
{93,8,10, "spiked Chain|325|piercing|t#3"},
{93,11,12, "Club|300|bludgeoning|thrown|t#3"},
{93,13,16, "hand Crossbow|400|piercing|t#3"},
{93,17,19, "repeating crossbow|550|piercing|t#3"},
{93,20,21, "punching Dagger|302|piercing|t#3"},
{93,22,23, "Falchion|375|slashing|t#3"},
{93,24,26, "dire Flail|690|bludgeoning|t#3|t#2"},
{93,27,31, "heavy Flail|315|bludgeoning|t#3"},
{93,32,35, "light Flail|308|bludgeoning|t#3"},
{93,36,37, "Gauntlet|302|bludgeoning|t#3"},
{93,38,39, "spiked Gauntlet|305|piercing|t#3"},
{93,40,41, "Glaive|308|slashing|t#3"},
{93,42,43, "Greatclub|305|bludgeoning|t#3"},
{93,44,45, "Guisarme|slashing|309|t#3"},
{93,46,48, "Halberd|310|piercing|slashing|t#3"},
{93,49,51, "Halfspear|301|piercing|thrown|t#3"},
{93,52,54, "gnome hooked Hammer|620|piercing|bludgeoning|t#3|t#2"},
{93,55,56, "light Hammer|301|bludgeoning|thrown|t#3"},
{93,57,58, "Handaxe|306|slashing|t#3"},
{93,59,61, "Kukri|308|slashing|t#3"},
{93,62,64, "Lance|310|piercing|t#3"},
{93,65,67, "Longspear|305|piercing|thrown|t#3"},
{93,68,70, "Morningstar|308|bludgeoning|t#3"},
{93,71,72, "Net|320|thrown|t#3"},
{93,73,74, "heavy Pick|308|piercing|t#3"},
{93,75,76, "light Pick|304|piercing|t#3"},
{93,77,78, "Ranseur|310|piercing|t#3"},
{93,79,80, "Sap|310|bludgeoning|t#3"},
{93,81,82, "Scythe|318|piercing|slashing|t#3"},
{93,83,84, "Shuriken|301|piercing|thrown|t#3"},
{93,85,86, "Sickle|306|slashing|t#3"},
{93,87,89, "two-bladed Sword|700|slashing|t#3|t#2"},
{93,90,91, "Trident|315|piercing|thrown|t#3"},
{93,92,94, "dwarven Urgrosh|650|slashing|piercing|t#3|t#2"},
{93,95,97, "Warhammer|312|bludgeoning|t#3"},
{93,98,100, "Whip|310|slashing|t#3"},
{94,1,10, "t#95|ammunition"},
{94,11,15, "throwing Axe|308|slashing|thrown|t#3"},
{94,16,25, "heavy Crossbow|350|piercing|t#3"},
{94,26,35, "light Crossbow|335|piercing|t#3"},
{94,36,39, "Dart|300|piercing|t#3"},
{94,40,41, "Javelin|301|piercing|t#3"},
{94,42,46, "Shortbow|330|piercing|t#3"},
{94,47,51, "composite Shortbow (+0 strength bonus)|375|piercing|t#3"},
{94,52,56, "composite Shortbow (+1 strength bonus)|450|piercing|t#3"},
{94,57,61, "composite Shortbow (+2 strength bonus)|525|piercing|t#3"},
{94,62,65, "Sling|300|bludgeoning|t#3"},
{94,66,75, "Longbow|375|piercing|t#3"},
{94,76,80, "composite Longbow|400|piercing|t#3"},
{94,81,85, "composite Longbow (+1 strength bonus)|500|piercing|t#3"},
{94,86,90, "composite Longbow (+2 strength bonus)|600|piercing|t#3"},
{94,91,95, "composite Longbow (+3 strength bonus)|700|piercing|t#3"},
{94,96,100, "composite Longbow (+4 strength bonus)|800|piercing|t#3"},
{94,1,50, "Arrows (bow)|1d50|7"},
{94,51,80, "Bolts (crossbow)|1d50|7"},
{94,81,100, "1d50|Bullets (sling)|7"},
{98,1,10, "1|bane|t#174"},
{98,11,17, "1|defending"},
{98,18,27, "1|flaming"},
{98,28,37, "1|Frost"},
{98,38,47, "1|Shock"},
{98,48,56, "1|ghost Touch"},
{98,57,67, "1|keen"},
{98,68,71, "1|Ki Focus"},
{98,72,75, "1|merciful"},
{98,76,82, "1|mighty cleaving"},
{98,83,87, "1|spell storing"},
{98,88,91, "1|throwing"},
{98,92,95, "1|thundering"},
{98,96,99, "1|vicious"},
{98,100,100, "t#98|1|t#98"},
{97,1,6, "1|bane|t#174"},
{97,7,12, "1|defending"},
{97,13,19, "1|flaming"},
{97,20,26, "1|Frost"},
{97,27,33, "1|Shock"},
{97,34,38, "1|ghost Touch"},
{97,39,44, "1|keen"},
{97,45,48, "1|Ki Focus"},
{97,49,50, "1|merciful"},
{97,51,54, "1|mighty cleaving"},
{97,55,59, "1|spell storing"},
{97,60,63, "1|throwing"},
{97,64,65, "1|thundering"},
{97,66,69, "1|vicious"},
{97,70,72, "2|anarchic"},
{97,73,75, "2|axiomatic"},
{97,76,78, "2|disruption"},
{97,79,81, "2|flaming Burst"},
{97,82,84, "2|icy Burst"},
{97,85,87, "2|holy"},
{97,88,90, "2|shocking Burst"},
{97,91,93, "2|unholy"},
{97,94,95, "2|wounding"},
{97,96,100, "t#97|1|t#97"},
{96,1,3, "1|bane|t#174"},
{96,4,6, "1|flaming"},
{96,7,9, "1|Frost"},
{96,10,12, "1|Shock"},
{96,13,15, "1|ghost Touch"},
{96,16,19, "1|Ki Focus"},
{96,20,21, "1|mighty cleaving"},
{96,22,24, "1|spell storing"},
{96,25,28, "1|throwing"},
{96,29,32, "1|thundering"},
{96,33,36, "1|vicious"},
{96,37,41, "2|anarchic"},
{96,42,46, "2|axiomatic"},
{96,47,49, "2|disruption"},
{96,50,54, "2|flaming Burst"},
{96,55,59, "2|icy Burst"},
{96,60,64, "2|holy"},
{96,65,69, "2|shocking Burst"},
{96,70,74, "2|unholy"},
{96,75,78, "2|wounding"},
{96,79,83, "3|speed"},
{96,84,86, "4|brilliant energy"},
{96,87,88, "4|dancing"},
{96,89,90, "5|vorpal"},
{96,91,100, "t#96|1|t#96"},
{101,1,12, "1|bane|t#174"},
{101,13,25, "1|distance"},
{101,26,40, "1|flaming"},
{101,41,55, "1|Frost"},
{101,56,60, "1|merciful"},
{101,61,68, "1|returning"},
{101,69,83, "1|shock"},
{101,84,93, "1|seeking"},
{101,94,99, "1|thundering"},
{101,100,100, "1|t#101|1|t#101"},
{100,1,8, "1|bane|t#174"},
{100,9,16, "1|distance"},
{100,17,28, "1|flaming"},
{100,29,40, "1|Frost"},
{100,41,42, "1|merciful"},
{100,43,47, "1|returning"},
{100,48,59, "1|shock"},
{100,60,64, "1|seeking"},
{100,65,68, "1|thundering"},
{100,69,71, "2|anarchic"},
{100,72,74, "2|axiomatic"},
{100,75,79, "2|flaming Burst"},
{100,80,82, "2|holy"},
{100,83,87, "2|icy Burst"},
{100,88,92, "2|shocking Burst"},
{100,93,95, "2|unholy"},
{100,96,100, "1|t#100|1|t#100"},
{99,1,4, "1|bane|t#174"},
{99,5,8, "1|distance"},
{99,9,12, "1|flaming"},
{99,13,16, "1|Frost"},
{99,17,21, "1|returning"},
{99,22,25, "1|shock"},
{99,26,27, "1|seeking"},
{99,28,29, "1|thundering"},
{99,30,34, "2|anarchic"},
{99,35,39, "2|axiomatic"},
{99,40,49, "2|flaming Burst"},
{99,50,54, "2|holy"},
{99,55,64, "2|icy Burst"},
{99,65,74, "2|shocking Burst"},
{99,75,79, "2|unholy"},
{99,80,84, "3|Speed"},
{99,85,90, "4|brilliant Energy"},
{99,91,100, "1|t#99|1|t#99"},
{174,1,5, "Aberrations"},
{174,6,9, "Animals"},
{174,10,16, "Constructs"},
{174,17,22, "Dragons"},
{174,23,27, "Elementals"},
{174,28,32, "Fey"},
{174,33,39, "Giants"},
{174,40,40, "aquatic Humanoids"},
{174,41,42, "dwarf Humanoids"},
{174,43,44, "elf Humanoids"},
{174,45,45, "gnoll Humanoids"},
{174,46,46, "gnome Humanoids"},
{174,47,49, "goblinoid Humanoids"},
{174,50,50, "halfling Humanoids"},
{174,51,54, "human Humanoids"},
{174,55,57, "reptilian Humanoids"},
{174,58,60, "orc Humanoids"},
{174,61,65, "Magical beasts"},
{174,66,70, "monstrous Humanoids"},
{174,71,72, "Oozes"},
{174,73,73, "air Outsider"},
{174,74,76, "chaotic Outsider"},
{174,77,77, "earth Outsider"},
{174,78,80, "evil Outsider"},
{174,81,81, "fire Outsider"},
{174,82,64, "good Outsider"},
{174,65,87, "lawful Outsider"},
{174,88,88, "water Outsider"},
{174,89,90, "Plants"},
{174,91,98, "Undead"},
{174,99,100, "Vermin"},
{104,1,15, "Sleep arrow|132|ranged|t#3"},
{104,16,25, "Screaming bolt|267|ranged|t#3"},
{104,26,45, "masterwork silver Dagger|322|melee|piercing slashing|t#3"},
{104,46,65, "masterwork cold iron Longsword|330|melee|slashing|t#3"},
{104,66,75, "javelin of Lightning|1500|ranged|piercing|t#3"},
{104,76,80, "Slaying arrow|2282|melee|t#3"},
{104,81,90, "adamantine Dagger|3002|melee|piercing slashing|t#3"},
{104,91,100, "adamantine Battleaxe|3010|melee|slashing|t#3"},
{103,1,9, "javelin of Lightning|1500|ranged|piercing|t#3"},
{103,10,15, "Slaying arrow|2282|melee|t#3"},
{103,16,24, "adamantine Dagger|3002|melee|piercing slashing|t#3"},
{103,25,33, "adamantine Battleaxe|3010|melee|slashing|t#3"},
{103,34,37, "slaying Arrow (greater)|4057|ranged|t#3"},
{103,38,40, "Shatterspike|4315|melee|slashing|t#3"},
{103,41,46, "Dagger of venom|8302|melee|piercing slashing|t#3"},
{103,47,51, "Trident of warning|10115|melee|piercing|t#3"},
{103,52,57, "Assassins Dagger|10302|melee|piercing slashing|t#3"},
{103,58,62, "Shifters sorrow|12780|melee|slashing|t#3"},
{103,63,66, "Trident of fish command|18650|melee|piercing|t#3"},
{103,67,74, "Flame tongue|20715|melee|slashing|t#3"},
{103,75,79, "Luck blade (0 wishes)|22060|melee|piercing|t#3"},
{103,80,86, "Sword of subtlety|22310|melee|piercing|t#3"},
{103,87,91, "Sword of the planes|22315|melee|slashing|t#3"},
{103,92,95, "Nine lives stealer|23057|melee|slashing|t#3"},
{103,96,98, "Sword of life stealing|25715|melee|slashing|t#3"},
{103,99,100, "Oathbow|25600|ranged|piercing|t#3"},
{102,1,4, "Assassins Dagger|10302|piercing slashing|t#3|melee"},
{102,5,7, "Shifters sorrow|12780|melee|slashing|t#3"},
{102,8,9, "Trident of fish command|18650|melee|piercing|t#3"},
{102,10,13, "Flame tongue|20715|melee|slashing|t#3"},
{102,14,17, "Luck blade (0 wishes)|22060|melee|piercing|t#3"},
{102,18,24, "Sword of subtlety|22310|melee|piercing|t#3"},
{102,25,31, "Sword of the planes|22315|melee|slashing|t#3"},
{102,32,37, "Nine lives stealer|23057|melee|slashing|t#3"},
{102,38,42, "Sword of life stealing|25715|melee|slashing|t#3"},
{102,43,46, "Oathbow|25600|ranged|slashing|t#3"},
{102,47,51, "Mace of terror|38552|melee|t#3"},
{102,52,57, "Life-drinker|40320|melee|slashing|t#3"},
{102,58,62, "Sylvan scimitar|47315|melee|slashing|t#3"},
{102,63,67, "Rapier of puncturing|50320|melee|slashing|t#3"},
{102,68,73, "Sun blade|50335|melee|slashing|t#3"},
{102,74,79, "Frost brand|54475|melee|slashing|t#3"},
{102,80,84, "Dwarven thrower|60312|ranged|bludgeoning|t#3"},
{102,85,91, "Luck Blade (1 wish)|62360|melee|piercing|t#3"},
{102,92,95, "Mace of smiting|75312|melee|bludgeoning|t#3"},
{102,96,97, "Luck blade (2 wishes)|102660|melee|piercing|t#3"},
{102,98,99, "Holy avenger|120630|melee|slashing|t#3"},
{102,100,100, "Luck blade (3 wishes)|142960|melee|piercing|t#3"},
{107,1,10, "Cure light wounds|50|Potion"},
{107,11,13, "Endure elements|50|Potion"},
{107,14,15, "Hide from animals|50|Potion"},
{107,16,17, "Hide from undead|50|Potion"},
{107,18,19, "Jump|50|Potion"},
{107,20,22, "Mage armor|50|Potion"},
{107,23,25, "Magic fang|50|Potion"},
{107,26,26, "Magic stone|50|Oil"},
{107,27,29, "Magic weapon|50|Oil"},
{107,30,30, "Pass without trace|50|Potion"},
{107,31,32, "Protected from|50|Potion|t#1"},
{107,33,34, "Remove fear|50|Potion"},
{107,35,35, "Sanctuary|50|Potion"},
{107,36,38, "Shield of faith +2|50|Potion"},
{107,39,39, "Shillelagh|50|Oil"},
{107,40,41, "Bless weapon|100|Oil"},
{107,42,44, "Enlarge person|250|Potion"},
{107,45,45, "Reduce person|250|Potion"},
{107,46,47, "Aid|300|Potion"},
{107,48,50, "Barkskin +2|300|Potion"},
{107,51,53, "Bears endurance|300|Potion"},
{107,54,56, "Blur|300|Potion"},
{107,57,59, "Bulls strength|300|Potion"},
{107,60,62, "Cats grace|300|Potion"},
{107,63,67, "Cure moderate wounds|300|Potion"},
{107,68,68, "Darkness|300|Oil"},
{107,69,71, "Darkvision|300|Potion"},
{107,72,74, "Delay poison|300|Potion"},
{107,75,76, "Eagles splendor|300|Potion"},
{107,77,78, "Fox cunning|300|Potion"},
{107,79,81, "Invisibility|300"},
{107,82,84, "Lesser restoration|300|Potion"},
{107,85,86, "Levitate person|300"},
{107,87,87, "Misdirection|300|Potion"},
{107,88,89, "Owls wisdom|300|Potion"},
{107,90,91, "Protection from arrows 1|300|Potion"},
{107,92,93, "Remove paralysis|300|Potion"},
{107,94,96, "Resist energy 10|300|Potion"},
{107,97,97, "Shield of faith +3|300|Potion"},
{107,98,99, "Spider climb|300|Potion"},
{107,100,100, "Undetectable alignment|300|Potion"},
{106,1,2, "Bless weapon|100|Oil"},
{106,3,4, "Enlarge person|250|Potion"},
{106,5,5, "Reduce person|250|Potion"},
{106,6,6, "Aid|300|Potion"},
{106,7,7, "Barkskin +2|300|Potion"},
{106,8,10, "Bears endurance|300|Potion"},
{106,11,13, "Blur|300|Potion"},
{106,14,16, "Bulls strength|300|Potion"},
{106,17,19, "Cats grace|300|Potion"},
{106,20,27, "Cure moderate wounds|300|Potion"},
{106,28,28, "Darkness|300|Oil"},
{106,29,30, "Darkvision|300|Potion"},
{106,31,31, "Delay poison|300|Potion"},
{106,32,33, "Eagles splendor|300|Potion"},
{106,34,35, "Fox cunning|300|Potion"},
{106,36,37, "Invisibility|300"},
{106,38,38, "Lesser restoration|300|Potion"},
{106,39,39, "Levitate person|300"},
{106,40,40, "Misdirection|300|Potion"},
{106,41,42, "Owls wisdom|300|Potion"},
{106,43,43, "Protection from arrows 1|300|Potion"},
{106,44,44, "Remove paralysis|300|Potion"},
{106,45,46, "Resist energy 10|300|Potion"},
{106,47,48, "Shield of faith +3|300|Potion"},
{106,49,49, "Spider climb|300|Potion"},
{106,50,50, "Undetectable alignment|300|Potion"},
{106,51,51, "Bardkskin +3|600|Potion"},
{106,52,52, "Shield of faith +4|600|Potion"},
{106,53,55, "Resist energy 20|700|Potion"},
{106,56,60, "Cure serious wounds|750|Potion"},
{106,61,61, "Daylight|750|Oil"},
{106,62,64, "Displacement|750|Potion"},
{106,65,65, "Flame arrow|750|Oil"},
{106,66,68, "Fly|750|Potion"},
{106,69,69, "Gaseous form|750|Potion"},
{106,70,71, "Greater magic fang +1|750|Potion"},
{106,72,73, "Greater magic weapon +1|750|Oil"},
{106,74,75, "Haste|750|Potion"},
{106,76,78, "Heroism|750|Potion"},
{106,79,80, "Keen edge|750|Oil"},
{106,81,81, "Magic circle agains|750|Potion|t#1"},
{106,82,83, "Magic vestment +1|750|Oil"},
{106,84,86, "Neutralize poison|750|Potion"},
{106,87,88, "Nondetection|750|Potion"},
{106,89,91, "Protection from energy|750|Potion"},
{106,92,93, "Rage|750|Potion"},
{106,94,94, "Remove blindnes|750|Potion"},
{106,95,95, "Remove curse|750|Potion"},
{106,96,96, "Remove disease|750|Potion"},
{106,97,97, "Tongues|750|Potion"},
{106,98,99, "Water breathing|750|Potion"},
{106,100,100, "Water walk|750|Potion"},
{105,1,2, "Blur|300|Potion"},
{105,3,7, "Cure moderate wounds|300|Potion"},
{105,8,8, "Darkvision|300|Potion"},
{105,9,11, "Invisibility|300"},
{105,12,12, "Lesser restoration|300|Potion"},
{105,13,13, "Remove paralysis|300|Potion"},
{105,14,14, "Shield of faith +3|300|Potion"},
{105,15,15, "Undetectable alignment|300|Potion"},
{105,16,16, "Bardkskin +3|600|Potion"},
{105,17,18, "Shield of faith +4|600|Potion"},
{105,19,20, "Resist energy 20|700|Potion"},
{105,21,28, "Cure serious wounds|750|Potion"},
{105,29,29, "Daylight|750|Oil"},
{105,30,32, "Displacement|750|Potion"},
{105,33,33, "Flame arrow|750|Oil"},
{105,34,38, "Fly|750|Potion"},
{105,39,39, "Gaseous form|750|Potion"},
{105,40,41, "Haste|750|Potion"},
{105,42,44, "Heroism|750|Potion"},
{105,45,46, "Keen edge|750|Oil"},
{105,47,47, "Magic circle agains|750|Potion|t#1"},
{105,48,50, "Neutralize poison|750|Potion"},
{105,51,52, "Nondetection|750|Potion"},
{105,53,54, "Protection from energy|750|Potion"},
{105,55,55, "Rage|750|Potion"},
{105,56,56, "Remove blindnes|750|Potion"},
{105,57,57, "Remove curse|750|Potion"},
{105,58,58, "Remove disease|750|Potion"},
{105,59,59, "Tongues|750|Potion"},
{105,60,60, "Water breathing|750|Potion"},
{105,61,61, "Water walk|750|Potion"},
{105,62,63, "Barkskin +4|900|Potion"},
{105,64,64, "Shield of faith +5|900|Potion"},
{105,65,65, "Good hope|1050|Potion"},
{105,66,68, "Resist energy 30|1100|Potion"},
{105,69,69, "Barkskin +5|1200|Potion"},
{105,70,73, "Greater magic fang +2|1200|Potion"},
{105,74,77, "Greater magic weapon +2|1200|Oil"},
{105,78,81, "Magic vestment +2|1200|Oil"},
{105,82,82, "Protection from arrows 15|1500|Potion"},
{105,83,85, "Greater magic fang +3|1800|Potion"},
{105,86,88, "Greater magic weapon +3|1800|Oil"},
{105,89,91, "Magic vestment +3|1800|Oil"},
{105,92,93, "Greater magic fang +4|2400|Potion"},
{105,94,95, "Greater magic weapon +4|2400|Oil"},
{105,96,97, "Magic vestment +4|2400|Oil"},
{105,98,98, "Greater magic fang +5|3000|Potion"},
{105,99,99, "Greater magic weapon +5|3000|Oil"},
{105,100,100, "Magic vestment +5|3000|Oil"},
// {,,, "|-|1|50|Potion"},		TODO
// {-,51,100, "Oil"},		TODO
{110,1, 18, "Protection +1|2000"},
{110,19, 28, "Feather falling|2200"},
{110,29, 36, "Sustenance|2500"},
{110,37, 44, "Climbing|2500"},
{110,45, 52, "Jumping|2500"},
{110,53, 60, "Swimming|2500"},
{110,61, 70, "Counterspells|4000"},
{110,71, 75, "Mind shielding|8000"},
{110,76, 80, "Protection +2|8000"},
{110,81, 85, "Force shield|8500"},
{110,86, 90, "Ram|8600"},
{110,91, 93, "Animal friendship|10800"},
{110,94, 96, "minor Energy resistance|12000"},
{110,97, 98, "Chameleon power|12700"},
{110,99, 100, "Water walking|15000"},
{109,1, 5, "Counterspells|4000"},
{109,6, 8, "Mind shielding|8000"},
{109,9, 18, "Protection +2|8000"},
{109,19, 23, "Force shield|8500"},
{109,24, 28, "Ram|8600"},
{109,29, 34, "Climbing (improved)|10000"},
{109,35, 40, "Jumping (improved)|10000"},
{109,41, 46, "Swimming (improved)|10000"},
{109,47, 51, "Animal friendship|10800"},
{109,52, 56, "minor Energy resistance|12000"},
{109,57, 61, "Chameleon power|12700"},
{109,62, 66, "Water walking|15000"},
{109,67, 71, "Protection +3|18000"},
{109,72, 76, "minor Spell storing|18000"},
{109,77, 81, "Invisibility|20000"},
{109,82, 85, "Wizardry (I)|20000"},
{109,86, 90, "Evasion|25000"},
{109,91, 93, "X-ray vision|25000"},
{109,94, 97, "Blinking|27000"},
{109,98, 100, "major energy Resistance|28000"},
{108,1, 2, "minor Energy resistance|12000"},
{108,3, 7, "Protection +3|18000"},
{108,8, 10, "minor Spell storing|18000"},
{108,11, 15, "Invisibility|20000"},
{108,16, 19, "Wizardry (I)|20000"},
{108,20, 25, "Evasion|25000"},
{108,26, 28, "X-ray vision|25000"},
{108,29, 32, "Blinking|27000"},
{108,33, 39, "major energy Resistance|28000"},
{108,40, 49, "Protection +4|32000"},
{108,50, 55, "Wizardry (II)|40000"},
{108,56, 60, "Freedom of movement|40000"},
{108,61, 63, "greater Energy Resistance|44000"},
{108,64, 65, "Friend shield (pair)|50000"},
{108,66, 70, "Protection +5|50000"},
{108,71, 74, "Shooting stars|50000"},
{108,75, 79, "Spell storing|50000"},
{108,80, 83, "Wizardry (III)|70000"},
{108,84, 86, "Telekinesis|75000"},
{108,87, 88, "Regeneration|90000"},
{108,89, 89, "Three wishes|97950"},
{108,90, 92, "Spell turning|98280"},
{108,93, 94, "Wizardry (IV)|100000"},
{108,95, 95, "Djinni calling|125000"},
{108,96, 96, "Elemental command (air)|200000"},
{108,97, 97, "Elemental command (earth)|200000"},
{108,98, 98, "Elemental command (fire)|200000"},
{108,99, 99, "Elemental command (water)|200000"},
{108,100, 100, "major Spell storing|200000"},
{112,1,7, "lesser (metamagic) Rod of enlarge Spell|3000"},
{112,8,14, "lesser (metamagic) Rod of extend Spell|3000"},
{112,15,21, "lesser (metamagic) Rod of silent Spell|3000"},
{112,22,28, "Immovable Rod|5000"},
{112,29,35, "lesser (metamagic) Rod of empower Spell|9000"},
{112,36,42, "Rod of metal and mineral Detection|10500"},
{112,43,53, "Rod of Cancellation|11000"},
{112,54,57, "(metamagic) Rod of enlarge Spell|11000"},
{112,58,61, "(metamagic) Rod of extend Spell|11000"},
{112,62,65, "(metamagic) Rod of silent Spell|11000"},
{112,66,71, "Rod of Wonder|12000"},
{112,72,79, "Rod of Python|13000"},
{112,80,83, "lesser (metamagic) Rod of maximize Spell|14000"},
{112,84,89, "Rod of Flame extinguishing|15000"},
{112,90,97, "Rod of Viper|19000"},
{112,98,99, "(metamagic) Rod of empower Spell|32500"},
{112,100,100, "lesser (metamagic) Rod of quicken Spell|35000"},
{111,1,4, "Rod of Cancellation|11000"},
{111,5,6, "(metamagic) Rod of enlarge Spell|11000"},
{111,7,8, "(metamagic) Rod of extend Spell|11000"},
{111,9,10, "(metamagic) Rod of silent Spell|11000"},
{111,11,14, "Rod of Wonder|12000"},
{111,15,18, "Rod of Python|13000"},
{111,19,21, "Rod of Flame extinguishing|15000"},
{111,22,25, "Rod of Viper|19000"},
{111,26,30, "Rod of enemy detection|23500"},
{111,31,36, "greater (metamagic) Rod of enlarge Spell|24500"},
{111,37,42, "greater (metamagic) Rod of extend Spell|24500"},
{111,43,48, "greater (metamagic) Rod of silent Spell|24500"},
{111,49,53, "Rod of Splendor|25000"},
{111,54,58, "Whitering|25000"},
{111,59,64, "(metamagic) Rod of empower Spell|32500"},
{111,65,69, "Rod of Thunder and Lightning|33000"},
{111,70,73, "lesser (metamagic) Rod of quicken Spell|35000"},
{111,74,77, "Rod of Negation|37000"},
{111,78,80, "Rod of Absorption|50000"},
{111,81,84, "Rod of Flailing|50000"},
{111,85,86, "(metamagic) Rod of maximize Spell|54000"},
{111,87,88, "Rod of Rulership|60000"},
{111,89,90, "Rod of Security|61000"},
{111,91,92, "Rod of lordly Might|70000"},
{111,93,94, "greater (metamagic) Rod of empower Spell|73000"},
{111,95,96, "(metamagic) Rod of quicken Spell|75500"},
{111,97,98, "Rof of Alertness|85000"},
{111,99,99, "greater (metamagic) Rod of maximize Spell|121500"},
{111,100,100, "greater (metamagic) Rod of quicken Spell|170000"},
{113,1,1, "intelligent item"},
{113,2,16, "design indicates wands function"},
{113,17,31, "inscription indicates wands function"},
{113,32,10, "Nothing"},
{117,1,70, "arcane|arcane"},
{117,71,100, "divine|divine"},
{120,1,100, "1d3|t#123"},
{119,1,100, "1d4|t#122"},
{118,1,100, "1d3|t#121"},
{123,1,5, "t#124|arcane|t#134|divine|0"},
{123,6,50, "t#125|arcane|t#135|divine|1"},
{123,51,95, "t#126|arcane|t#136|divine|2"},
{123,96,100, "3|t#127|arcane|t#137|divine"},
{122,1,5, "2|t#126|arcane|t#136|divine"},
{122,6,65, "3|t#127|arcane|t#137|divine"},
{122,66,95, "4|t#128|arcane|t#138|divine"},
{122,96,100, "5|t#129|arcane|t#139|divine"},
{121,1,5, "4|t#128|arcane|t#138|divine"},
{121,6,50, "5|t#129|arcane|t#139|divine"},
{121,51,70, "6|t#130|arcane|t#140|divine"},
{121,71,85, "7|t#131|arcane|t#141|divine"},
{121,86,95, "8|t#132|arcane|t#142|divine"},
{121,96,100, "9|t#133|arcane|t#143|divine"},
{124,1,4, "acid splash|12.5"},
{124,5,8, "arcane mark|12.5"},
{124,9,13, "dancing lights|12.5"},
{124,14,17, "daze|12.5"},
{124,18,24, "detect magic|12.5"},
{124,25,28, "detect poison|12.5"},
{124,29,32, "disrupt undead|12.5"},
{124,33,37, "flare|12.5"},
{124,38,42, "ghost sound|12.5"},
{124,43,44, "know direction|12.5"},
{124,45,50, "light|12.5"},
{124,51,52, "lullaby|12.5"},
{124,53,57, "mage hand|12.5"},
{124,58,62, "mending|12.5"},
{124,63,67, "message|12.5"},
{124,68,72, "ope|12.5"},
{124,73,77, "predistigation|12.5"},
{124,78,81, "ray of frost|12.5"},
{124,82,87, "read magic|12.5"},
{124,88,94, "resistance|12.5"},
{124,95,96, "summon instrument|12.5"},
{124,97,100, "touch of fatigue|12.5"},
{125,1,3, "alarm|25"},
{125,4,5, "animate rope|25"},
{125,6,7, "burning hands|25"},
{125,8,9, "cause fear|25"},
{125,10,12, "charm person|25"},
{125,13,14, "chill touch|25"},
{125,15,16, "color spray|25"},
{125,17,19, "comprehend languages|25"},
{125,20,20, "confusion, lesser|50"},
{125,21,21, "cure light wounds|50"},
{125,22,24, "detect secret doors|25"},
{125,25,26, "detect undead|25"},
{125,27,29, "disguise self|25"},
{125,30,32, "endure elements|25"},
{125,33,35, "enlarge person|25"},
{125,36,37, "erase|25"},
{125,38,40, "expeditious retreat|25"},
{125,41,41, "feather fall|25"},
{125,42,43, "grease|25"},
{125,44,45, "hold portal|25"},
{125,46,47, "hypnotism|25"},
{125,48,49, "identify|125"},
{125,50,51, "jump|25"},
{125,52,54, "mage armor|25"},
{125,55,56, "magic missile|25"},
{125,57,59, "magic weapon|25"},
{125,60,62, "mount|25"},
{125,63,64, "magic aura|25"},
{125,65,66, "obscuring mist|25"},
{125,67,74, "protection from chao|25"},
{125,75,76, "ray of enfeeblement|25"},
{125,77,78, "reduce person|25"},
{125,79,80, "remove fear|25"},
{125,81,82, "shield|25"},
{125,83,84, "shocking grasp|25"},
{125,85,86, "silent image|25"},
{125,87,88, "sleep|25"},
{125,89,90, "summon monster I|25"},
{125,91,93, "floating disk|25"},
{125,94,95, "true strike|25"},
{125,96,96, "undetectable alignment|50"},
{125,97,98, "unseen servant|25"},
{125,99,100, "ventriloquism|25"},
{126,1,1, "animal messenger|200"},
{126,2,2, "animal trance|200"},
{126,3,3, "arcane lock|175"},
{126,4,6, "bears endurance|150"},
{126,7,8, "blindnes|150"},
{126,9,10, "blur|150"},
{126,11,13, "bulls strength|150"},
{126,14,14, "calm emotions|200"},
{126,15,17, "cats grace|150"},
{126,18,19, "command undead|150"},
{126,20,20, "continual flame|200"},
{126,21,21, "cure moderate wounds|200"},
{126,22,22, "darkness|150"},
{126,23,25, "darkvision|150"},
{126,26,26, "daze monster|150"},
{126,27,27, "delay poison|200"},
{126,28,29, "detect thoughts|150"},
{126,30,31, "disguise self|150"},
{126,32,34, "eagles splendor|150"},
{126,35,35, "enthrall|200"},
{126,36,37, "false life|150"},
{126,38,39, "flaming sphere|150"},
{126,40,40, "fog cloud|150"},
{126,41,43, "foxs cunning|150"},
{126,44,44, "ghoul touch|150"},
{126,45,46, "glitterdust|150"},
{126,47,47, "ghust of wind|150"},
{126,48,49, "hypnotic pattern|150"},
{126,50,52, "invisibility|150"},
{126,53,55, "knock|150"},
{126,56,56, "phantom trap|200"},
{126,57,58, "levitate|150"},
{126,59,60, "magic mouth|160"},
{126,61,62, "acid arrow|150"},
{126,63,63, "minor image|150"},
{126,64,65, "mirror image|150"},
{126,66,66, "misdirection|150"},
{126,67,67, "obscure object|150"},
{126,68,70, "owls wisdom|150"},
{126,71,73, "protection from arrows|150"},
{126,74,75, "pyrotechnics|150"},
{126,76,78, "resist energy|150"},
{126,79,79, "rope trick|150"},
{126,80,80, "scare|150"},
{126,81,82, "scorching ray|150"},
{126,83,85, "see invisibility|150"},
{126,86,86, "shatter|150"},
{126,87,87, "silence|200"},
{126,88,88, "sound burst|200"},
{126,89,89, "spectral hand|150"},
{126,90,91, "spider climb|150"},
{126,92,93, "summon monster II|150"},
{126,94,95, "summon swarm|150"},
{126,96,96, "hideous laughter|150"},
{126,97,97, "touch of idiocy|150"},
{126,98,99, "web|150"},
{126,100,100, "whispering wind|150"},
{127,1,2, "arcane sight|375"},
{127,3,4, "blink|375"},
{127,5,6, "clairaudienc|375"},
{127,7,7, "cure serious wounds|525"},
{127,8,10, "daylight|375"},
{127,11,12, "deep slumber|375"},
{127,13,15, "dispel magic|375"},
{127,16,17, "displacement|375"},
{127,18,18, "explosive runes|375"},
{127,19,20, "fireball|375"},
{127,21,22, "flame arrow|375"},
{127,23,25, "fly|375"},
{127,26,27, "gaseous form|375"},
{127,28,29, "gentle repose|375"},
{127,30,30, "glibness|525"},
{127,31,31, "good hope|525"},
{127,32,33, "halt undead|375"},
{127,34,36, "haste|375"},
{127,37,38, "heroism|375"},
{127,39,40, "hold person|375"},
{127,41,41, "illusory script|425"},
{127,42,44, "invisibility sphere|375"},
{127,45,47, "keen edge|375"},
{127,48,49, "Leomunds tiny hut|375"},
{127,50,51, "lightning bolt|375"},
{127,52,59, "magic circle agains chao|375"},
{127,60,62, "magic weapon, greater|375"},
{127,63,64, "major image|375"},
{127,65,66, "nondetection|425"},
{127,67,68, "phantom steed|375"},
{127,69,71, "protection from energy|375"},
{127,72,73, "rage|375"},
{127,74,75, "ray of exhaustion|375"},
{127,76,76, "sculpt sound|525"},
{127,77,77, "secret page|375"},
{127,78,78, "sepia snake sigil|875"},
{127,79,79, "shrink item|375"},
{127,80,81, "sleet storm|375"},
{127,82,83, "slow|375"},
{127,84,84, "speak with animals|525"},
{127,85,86, "stinkink cloud|375"},
{127,87,88, "suggestion|375"},
{127,89,90, "summon monster III|375"},
{127,91,93, "tongues|375"},
{127,94,95, "vampiric touch|375"},
{127,96,98, "water breathing|375"},
{127,99,100, "wind wall|375"},
{128,1,2, "animate dead|1050"},
{128,3,5, "arcane eye|700"},
{128,6,7, "bestow curse|700"},
{128,8,10, "charm monster|700"},
{128,11,13, "confusion|700"},
{128,14,15, "contagion|700"},
{128,16,17, "crushing despair|700"},
{128,18,18, "cure critical wounds|1000"},
{128,19,19, "detect scrying|700"},
{128,20,23, "dimension door|700"},
{128,24,26, "dimensional anchor|700"},
{128,27,28, "enervation|700"},
{128,29,30, "enlarge person, mass|700"},
{128,31,32, "black tentacles|700"},
{128,33,34, "fear|700"},
{128,35,37, "fire shield|700"},
{128,38,39, "fire trap|725"},
{128,40,42, "freedom of movement|1000"},
{128,43,43, "geas, lesser|700"},
{128,44,46, "globe of invulnerability, lesser|700"},
{128,47,48, "hallucinatory terrain|700"},
{128,49,50, "ice storm|700"},
{128,51,52, "illusory wall|700"},
{128,53,55, "invisibility, greater|700"},
{128,56,57, "secure shelter|700"},
{128,58,58, "locate creature|700"},
{128,59,60, "minor creation|700"},
{128,61,61, "modify memory|1000"},
{128,62,62, "neutralize poison|1000"},
{128,63,64, "resilient sphere|700"},
{128,65,66, "phantasmal killer|700"},
{128,67,68, "polymorph|700"},
{128,69,70, "rainbow pattern|700"},
{128,71,71, "mnemonic enhancer|700"},
{128,72,73, "reduce person, mass|700"},
{128,74,76, "remove curse|700"},
{128,77,77, "repel vermin|1000"},
{128,78,79, "srying|700"},
{128,80,81, "shadow conjuration|700"},
{128,82,83, "shout|700"},
{128,84,85, "solid fog|700"},
{128,86,86, "speak with plants|1000"},
{128,87,88, "stone shape|700"},
{128,89,91, "stoneskin|950"},
{128,92,93, "summon monster IV|700"},
{128,94,96, "wall of fire|700"},
{128,97,99, "wall of ice|700"},
{128,100,100, "zone of silence|1000"},
{129,1,2, "animal growth|1125"},
{129,3,5, "baleful polymorph|1125"},
{129,6,7, "interposing hand|1125"},
{129,8,9, "blight|1125"},
{129,10,12, "break enchantment|1125"},
{129,13,14, "cloudkill|1125"},
{129,15,17, "cone of cold|1125"},
{129,18,19, "contact other plane|1125"},
{129,20,20, "cure light wounds, mass|1625"},
{129,21,23, "dismissal|1125"},
{129,24,26, "dispel magic, greater|1625"},
{129,27,28, "dominate person|1125"},
{129,29,29, "dream|1125"},
{129,30,31, "fabricate|1125"},
{129,32,33, "false vision|1375"},
{129,34,35, "feeblemind|1125"},
{129,36,39, "hold monster|1125"},
{129,40,40, "secret chest|1125"},
{129,41,41, "magic jar|1125"},
{129,42,43, "major creation|1125"},
{129,44,45, "mind fog|1125"},
{129,46,47, "mirage arcana|1125"},
{129,48,49, "mages faithful hand|1125"},
{129,50,51, "mages private sanctum|1125"},
{129,52,53, "nightmare|1125"},
{129,54,57, "overland flight|1125"},
{129,58,60, "passwall|1125"},
{129,61,61, "permancency|10125"},
{129,62,63, "persistent image|1125"},
{129,64,65, "planar binding, lesser|1125"},
{129,66,67, "prying eyes|1125"},
{129,68,69, "telepathic bond|1125"},
{129,70,71, "seeming|1125"},
{129,72,74, "sending|1125"},
{129,75,76, "shadow evocation|1125"},
{129,77,77, "song of discord|1625"},
{129,78,79, "summon monster V|1125"},
{129,80,80, "symbol of pain|2125"},
{129,81,81, "symbol of sleep|2125"},
{129,82,83, "telekinesis|1125"},
{129,84,88, "teleport|1125"},
{129,89,90, "transmute mud to rock|1125"},
{129,91,92, "transmute rock to mud|1125"},
{129,93,95, "wall of force|1125"},
{129,96,98, "wall of stone|1125"},
{129,99,100, "waves of fatigue|1125"},
{130,1,2, "acid fog|1650"},
{130,3,5, "analyze dweomer|1650"},
{130,6,6, "animate objects|2400"},
{130,7,9, "antimagic field|1650"},
{130,10,12, "bears endurance, mass|1650"},
{130,13,14, "forceful hand|1650"},
{130,15,17, "bulls strength, mass|1650"},
{130,18,20, "cats grace, mass|1650"},
{130,21,23, "chain lightning|1650"},
{130,24,25, "circle of death|2150"},
{130,26,26, "contingency|1650"},
{130,27,28, "control water|1650"},
{130,29,29, "created undead|2350"},
{130,30,30, "cure moderate wounds, mass|2400"},
{130,31,33, "disintegrate|1650"},
{130,34,37, "dispel magic, greater|1650"},
{130,38,40, "eagles splendor, mass|1650"},
{130,41,42, "eyebite|1650"},
{130,43,43, "find the path|2400"},
{130,44,45, "flesh to stone|1650"},
{130,46,48, "foxs cunning, mass|1650"},
{130,49,49, "gea|1650"},
{130,50,52, "globe of invulnerability|1650"},
{130,53,53, "guards and wards|1650"},
{130,54,54, "heroes feast|2400"},
{130,55,56, "heroism, greater|1650"},
{130,57,57, "legend lore|1900"},
{130,58,59, "mislead|1650"},
{130,60,60, "mages lucubration|1650"},
{130,61,62, "move earth|1650"},
{130,63,64, "freezing sphere|1650"},
{130,65,67, "owls wisdom, mass|1650"},
{130,68,69, "permanent image|1650"},
{130,70,71, "planar binding|1650"},
{130,72,73, "programmed image|1675"},
{130,74,75, "repulsion|1650"},
{130,76,78, "shadow walk|1650"},
{130,79,81, "stone to flesh|1650"},
{130,82,83, "suggestion, mass|1650"},
{130,84,85, "summon monster VI|1650"},
{130,86,86, "symbol of fear|2650"},
{130,87,87, "symbol of persuasion|6650"},
{130,88,88, "symphathetic vibration|2400"},
{130,89,90, "transformation|1950"},
{130,91,93, "true seeing|1900"},
{130,94,95, "undeath to death|2150"},
{130,96,97, "veil|1650"},
{130,98,100, "wall of iron|1700"},
{131,1,3, "greater arcane sight|2275"},
{131,4,7, "banishment|2275"},
{131,8,10, "grasping hand|2275"},
{131,11,13, "control undead|2275"},
{131,14,16, "control weather|2275"},
{131,17,19, "delayed blast fireball|2275"},
{131,20,21, "instant summons|3275"},
{131,22,25, "ethereal jaunt|2275"},
{131,26,28, "finger of death|2275"},
{131,29,31, "forcecage|23775"},
{131,32,35, "hold person, mass|2275"},
{131,36,38, "insanity|2275"},
{131,39,42, "invisibility, mass|2275"},
{131,43,43, "limited wish|3775"},
{131,44,45, "mages magnificent mansion|2275"},
{131,46,48, "mages sword|2275"},
{131,49,51, "phase door|2275"},
{131,52,54, "plane shift|2275"},
{131,55,57, "power word blind|2275"},
{131,58,61, "prismatic spray|2275"},
{131,62,64, "project image|2280"},
{131,65,67, "reverse gravity|2275"},
{131,68,70, "scrying, greater|2275"},
{131,71,73, "sequester|2275"},
{131,74,76, "shadow conjuration, greater|2275"},
{131,77,77, "simulacrum|7275"},
{131,78,80, "spell turning|2275"},
{131,81,82, "statue|2275"},
{131,83,85, "summon monster VII|2275"},
{131,86,86, "symbol of stunning|7275"},
{131,87,87, "symbol of weakness|7275"},
{131,88,90, "teleport object|275"},
{131,91,95, "teleport, greater|2275"},
{131,96,97, "vision|2775"},
{131,98,100, "waves of exhaustion|2275"},
{132,1,2, "antipathy|3000"},
{132,3,5, "clenched fist|3000"},
{132,6,8, "binding|8500"},
{132,9,12, "charm monster, mass|3000"},
{132,13,13, "clone|4000"},
{132,14,16, "create greater undead|3000"},
{132,17,19, "demand|3600"},
{132,20,22, "dimensional lock|3000"},
{132,23,26, "discern location|3000"},
{132,27,29, "horrid wilting|3000"},
{132,30,32, "incendiary cloud|3000"},
{132,33,35, "iron body|3000"},
{132,36,38, "maze|3000"},
{132,39,41, "mind blank|3000"},
{132,42,44, "moment of persistence|3000"},
{132,45,48, "telekinetic sphere|3000"},
{132,49,51, "Ottos irresistible dance|3000"},
{132,52,54, "planar binding, greater|3000"},
{132,55,57, "polar ray|3000"},
{132,58,60, "polymorph any object|3000"},
{132,61,63, "power word stun|3000"},
{132,64,66, "prismatic wall|3000"},
{132,67,70, "protection from spells|3500"},
{132,71,73, "prying eyes, greater|3000"},
{132,74,76, "scintillating pattern|3000"},
{132,77,78, "screen|3000"},
{132,79,81, "shadow evocation, greater|3000"},
{132,82,84, "shout, greater|3000"},
{132,85,87, "summon monster VIII|3000"},
{132,88,90, "sunburst|3000"},
{132,91,91, "symbol of death|8000"},
{132,92,92, "symbol of insanity|8000"},
{132,93,94, "sympathy|4500"},
{132,95,98, "temporal statis|3500"},
{132,99,100, "trap the soul|13000"},
{133,1,3, "astral projection|4870"},
{133,4,7, "crushing hand|3825"},
{133,8,12, "dominate monster|3825"},
{133,13,16, "energy drain|3825"},
{133,17,21, "etherrealness|3825"},
{133,22,25, "foresight|3825"},
{133,26,31, "freedom|3825"},
{133,32,36, "gate|8825"},
{133,37,40, "hold monster, mass|3825"},
{133,41,44, "imprisonment|3825"},
{133,45,49, "meteor swarm|3825"},
{133,50,53, "mages disjunction|3825"},
{133,54,58, "power word kill|3825"},
{133,59,62, "prismatic sphere|3825"},
{133,63,66, "refuge|3825"},
{133,67,70, "shades|3825"},
{133,71,76, "shapechange|3825"},
{133,77,79, "sould bind|3825"},
{133,80,83, "summon monster IX|3825"},
{133,84,86, "teleportation circle|4825"},
{133,87,91, "time stop|3825"},
{133,92,95, "wail of the banshee|3825"},
{133,96,99, "weird|3825"},
{133,100,100, "wish|28825"},
{134,1,7, "create water|12.5"},
{134,8,14, "cure minor wounds|12.5"},
{134,15,22, "detect magic|12.5"},
{134,23,29, "detect poison|12.5"},
{134,30,36, "flare|12.5"},
{134,37,43, "guidance|12.5"},
{134,44,50, "inflict minor wounds|12.5"},
{134,51,57, "know direction|12.5"},
{134,58,65, "light|12.5"},
{134,66,72, "mending|12.5"},
{134,73,79, "purify food and drink|12.5"},
{134,80,86, "read magic|12.5"},
{134,87,93, "resistance|12.5"},
{134,94,100, "virtue|12.5"},
{135,1,1, "alarm|100"},
{135,2,3, "bane|25"},
{135,4,6, "bless|25"},
{135,7,9, "bless water|50"},
{135,10,10, "bless weapon|100"},
{135,11,12, "calm animals|25"},
{135,13,14, "cause fear|25"},
{135,15,16, "charm animal|25"},
{135,17,19, "command|25"},
{135,20,21, "comprehend languages|25"},
{135,22,26, "cure light wounds|25"},
{135,27,28, "curse water|50"},
{135,29,30, "deathwatch|25"},
{135,31,32, "detect animals or plants|25"},
{135,33,35, "detect chao|25"},
{135,36,37, "detect snares and pits|25"},
{135,38,39, "detect undead|25"},
{135,40,41, "divine favor|25"},
{135,42,43, "doom|25"},
{135,44,48, "endure elements|25"},
{135,49,50, "entangle|25"},
{135,51,52, "entropic shield|25"},
{135,53,54, "faerie fire|25"},
{135,55,56, "goodberry|25"},
{135,57,58, "hide from animals|25"},
{135,59,60, "hide from undead|25"},
{135,61,62, "inflict light wounds|25"},
{135,63,64, "jump|25"},
{135,65,66, "longstrider|25"},
{135,67,68, "magic fang|25"},
{135,69,72, "magic stone|25"},
{135,73,74, "magic weapon|25"},
{135,75,78, "obscuring mist|25"},
{135,79,80, "pass without trace|25"},
{135,81,82, "produce flame|25"},
{135,83,86, "protection from chao|25"},
{135,87,88, "remove fear|25"},
{135,89,90, "sanctuary|25"},
{135,91,92, "shield of faith|25"},
{135,93,94, "shillelagh|25"},
{135,95,96, "speak with animals|25"},
{135,97,98, "summon monster I|25"},
{135,99,100, "summon natures ally I|25"},
{136,1,1, "animal messenger|150"},
{136,2,2, "animal trance|150"},
{136,3,4, "augury|175"},
{136,5,6, "barkskin|150"},
{136,7,9, "bears endurance|150"},
{136,10,12, "bulls strength|150"},
{136,13,14, "calm emotions|150"},
{136,15,17, "cats grace|150"},
{136,18,18, "chill metal|150"},
{136,19,20, "consecrate|200"},
{136,21,24, "cure moderate wounds|150"},
{136,25,26, "darkness|150"},
{136,27,27, "death knell|150"},
{136,28,30, "delay poison|150"},
{136,31,32, "desecreate|150"},
{136,33,35, "eagles splendor|150"},
{136,36,37, "enthrall|150"},
{136,38,39, "find traps|150"},
{136,40,40, "fire trap|175"},
{136,41,42, "flame blade|150"},
{136,43,44, "flaming sphere|150"},
{136,45,46, "fog cloud|150"},
{136,47,47, "gentle repose|150"},
{136,48,48, "gust of wind|150"},
{136,49,49, "heat metal|150"},
{136,50,51, "hold animal|150"},
{136,52,54, "hold person|150"},
{136,55,56, "inflict moderate wounds|150"},
{136,57,58, "make whole|150"},
{136,59,61, "owls wisdom|150"},
{136,62,62, "reduce animal|150"},
{136,63,64, "remove paralysis|150"},
{136,65,67, "resist energy|150"},
{136,68,70, "restoration, lesser|150"},
{136,71,72, "shatter|150"},
{136,73,74, "shield other|150"},
{136,75,76, "silence|150"},
{136,77,77, "snare|150"},
{136,78,78, "soften earth and stone|150"},
{136,79,80, "sound burst|150"},
{136,81,81, "speak with animals|150"},
{136,82,83, "spider climb|150"},
{136,84,85, "spiritual weapon|150"},
{136,86,86, "status|150"},
{136,87,88, "summon monster II|150"},
{136,89,90, "summon natures ally II|150"},
{136,91,92, "summon swarm|150"},
{136,93,93, "tree shape|150"},
{136,94,95, "undetectable alignment|150"},
{136,96,97, "warp wood|150"},
{136,98,98, "wood shape|150"},
{136,99,100, "zone of truth|150"},
{137,1,2, "animate dead|625"},
{137,3,4, "bestow curse|375"},
{137,5,6, "blindnes|375"},
{137,7,8, "call lightning|375"},
{137,9,10, "contagion|375"},
{137,11,12, "continual flame|425"},
{137,13,14, "create food and water|375"},
{137,15,18, "cure serious wounds|375"},
{137,19,19, "darkvision|375"},
{137,20,21, "daylight|375"},
{137,22,23, "deeper darkness|375"},
{137,24,25, "diminish plants|375"},
{137,26,27, "dispel magic|375"},
{137,28,29, "dominate animal|375"},
{137,30,31, "glyph of warding|575"},
{137,32,32, "heal mount|375"},
{137,33,34, "helping hand|375"},
{137,35,36, "inflict serious wounds|375"},
{137,37,38, "invisibility purge|375"},
{137,39,40, "locate object|375"},
{137,41,46, "magic circle against chao|375"},
{137,47,48, "magic fang, greater|375"},
{137,49,50, "magic vestment|375"},
{137,51,52, "meld into stone|375"},
{137,53,55, "neutralize poison|375"},
{137,56,57, "obscure object|375"},
{137,58,59, "plant growth|375"},
{137,60,62, "prayer|375"},
{137,63,64, "protection from energy|375"},
{137,65,66, "quench|375"},
{137,67,69, "remove blindnes|375"},
{137,70,71, "remove curse|375"},
{137,72,73, "remove disease|375"},
{137,74,76, "searing light|375"},
{137,77,78, "sleet storm|375"},
{137,79,80, "snare|375"},
{137,81,83, "speak with dead|375"},
{137,84,85, "speak with plants|375"},
{137,86,87, "spike growth|375"},
{137,88,89, "stone shape|375"},
{137,90,91, "summon monster III|375"},
{137,92,93, "summon natures ally III|375"},
{137,94,96, "water breathing|375"},
{137,97,98, "water walk|375"},
{137,99,100, "wind wall|375"},
{138,1,5, "air walk|700"},
{138,6,7, "antiplant shell|700"},
{138,8,9, "blight|700"},
{138,10,11, "break enchantment|700"},
{138,12,13, "command plants|700"},
{138,14,15, "control water|700"},
{138,16,21, "cure critical wounds|700"},
{138,22,26, "death ward|700"},
{138,27,31, "dimension anchor|700"},
{138,32,34, "discern lies|700"},
{138,35,37, "dismissal|700"},
{138,38,39, "divination|725"},
{138,40,42, "divine power|700"},
{138,43,47, "freedom of movement|700"},
{138,48,49, "giant vermin|700"},
{138,50,51, "holy sword|700"},
{138,52,54, "imbue with spell ability|700"},
{138,55,57, "inflict critical wounds|700"},
{138,58,60, "magic weapon, greater|700"},
{138,61,62, "nondetection|750"},
{138,63,64, "planar ally, lesser|1200"},
{138,65,67, "poison|700"},
{138,68,69, "reincarnate|700"},
{138,70,71, "repel vermin|700"},
{138,72,76, "restoration|800"},
{138,77,78, "rusting grasp|700"},
{138,79,81, "sending|700"},
{138,82,85, "spell immunity|700"},
{138,86,87, "spike stones|700"},
{138,88,90, "summon monster IV|700"},
{138,91,93, "summon natures ally IV|700"},
{138,94,98, "tongues|700"},
{138,99,100, "tree stride|700"},
{139,1,3, "animal growth|1125"},
{139,4,5, "atonement|3625"},
{139,6,6, "awaken|2375"},
{139,7,9, "baleful polymorph|1125"},
{139,10,13, "break enchantment|1125"},
{139,14,16, "call lightning storm|1125"},
{139,17,20, "command, greater|1125"},
{139,21,21, "commune|1625"},
{139,22,22, "commune with nature|1125"},
{139,23,24, "control winds|1125"},
{139,25,30, "cure light wounds, mass|1125"},
{139,31,34, "dispel chao|1125"},
{139,35,38, "disrupting weapon|1125"},
{139,39,41, "flame strike|1125"},
{139,42,43, "hallow|6125"},
{139,44,46, "ice storm|1125"},
{139,47,49, "inflict light wounds, mass|1125"},
{139,50,52, "insect plague|1125"},
{139,53,53, "mark of justice|1125"},
{139,54,56, "plane shift|1125"},
{139,57,58, "raise dead|6125"},
{139,59,61, "righteous might|1125"},
{139,62,63, "scrying|1125"},
{139,64,66, "slay living|1125"},
{139,67,69, "spell resistance|1125"},
{139,70,71, "stoneskin|1125"},
{139,72,74, "summon monster V|1125"},
{139,75,77, "summon natures ally V|1125"},
{139,78,78, "symbol of pain|2125"},
{139,79,79, "symbol of sleep|2125"},
{139,80,82, "transmute mud to rock|1125"},
{139,83,85, "transmute rock to mud|1125"},
{139,86,89, "true seeing|1375"},
{139,90,91, "unhallow|6125"},
{139,92,94, "wall of fire|1125"},
{139,95,97, "wall of stone|1125"},
{139,98,100, "wall of thorns|1125"},
{140,1,3, "animate objects|1650"},
{140,4,6, "antilife shell|1650"},
{140,7,9, "banishment|1650"},
{140,10,13, "bears endurance, mass|1650"},
{140,14,16, "blade barrier|1650"},
{140,17,20, "bulls strength, mass|1650"},
{140,21,24, "cats grace|1650"},
{140,25,25, "create undead|1650"},
{140,26,29, "cure moderate wounds, mass|1650"},
{140,30,33, "dispel magic, greater|1650"},
{140,34,37, "eagles splendor, mass|1650"},
{140,38,40, "find the path|1650"},
{140,41,43, "fire seeds|1650"},
{140,44,44, "forbiddance|4650"},
{140,45,45, "gea|1650"},
{140,46,46, "glyph of warding, greate|1650"},
{140,47,49, "harm|1650"},
{140,50,52, "heal|1650"},
{140,53,55, "heroes feast|1650"},
{140,56,58, "inflict moderate wounds, mass|1650"},
{140,59,61, "ironwood|1650"},
{140,62,62, "liveoak|1650"},
{140,63,65, "move earth|1650"},
{140,66,69, "owls wisdom, mass|1650"},
{140,70,71, "planar ally|2400"},
{140,72,74, "repel wood|1650"},
{140,75,77, "spellstaff|1650"},
{140,78,80, "stone tell|1650"},
{140,81,83, "summon monster VI|1650"},
{140,84,86, "summon natures ally VI|1650"},
{140,87,87, "symbol of fear|2650"},
{140,88,88, "symbol of persuasion|6650"},
{140,89,91, "transport via plants|1650"},
{140,92,94, "undeath to death|2150"},
{140,95,97, "wind walk|1650"},
{140,98,100, "word of recall|1650"},
{141,1,5, "animate plants|2275"},
{141,6,9, "blasphemy|2275"},
{141,10,14, "changestaff|2275"},
{141,15,16, "control weather|2275"},
{141,17,21, "creeping doom|2275"},
{141,22,27, "cure serious wounds, mass|2275"},
{141,28,32, "destruction|2275"},
{141,33,36, "dictum|2275"},
{141,37,41, "ethereal jaunt|2275"},
{141,42,45, "holy word|2275"},
{141,46,50, "inflict serious wounds, mass|2275"},
{141,51,55, "refuge|3775"},
{141,56,60, "regenerate|2275"},
{141,61,65, "repulsion|2275"},
{141,66,69, "restoration, greater|4775"},
{141,70,71, "resurrection|12275"},
{141,72,76, "srying, greater|2275"},
{141,77,81, "summon monster VII|2275"},
{141,82,85, "summon natures ally VII|2275"},
{141,86,90, "sunbeam|2275"},
{141,91,91, "symbol of stunning|7275"},
{141,92,92, "symbol of weakness|7275"},
{141,93,97, "transmute metal to wook|2275"},
{141,98,100, "word of chaos|2275"},
{142,1,4, "animal shapes|3000"},
{142,5,10, "antimagic field|3000"},
{142,11,13, "cloak of chaos|3000"},
{142,14,17, "control plants|3000"},
{142,18,20, "create greater undead|3600"},
{142,21,27, "cure critical wounds, mass|3000"},
{142,28,32, "dimension lock|3000"},
{142,33,36, "discern location|3000"},
{142,37,41, "earthquake|3000"},
{142,42,45, "finger of death|3000"},
{142,46,49, "fire storm|3000"},
{142,50,52, "holy aura|3000"},
{142,53,56, "inflict critical wounds, mass|3000"},
{142,57,60, "planar ally, greater|5500"},
{142,61,65, "repel metal or stone|3000"},
{142,66,69, "reverse gravity|3000"},
{142,70,72, "shield of law|3000"},
{142,73,76, "spell immunity, greater|3000"},
{142,77,80, "summon monster VIII|3000"},
{142,81,84, "summon natures ally VIII|3000"},
{142,85,89, "sunburst|3000"},
{142,90,91, "symbol of death|8000"},
{142,92,93, "symbol of insanity|8000"},
{142,94,96, "unholy aura|3000"},
{142,97,100, "whirlwind|3000"},
{143,1,3, "antipathy|3825"},
{143,4,7, "astral projection|4870"},
{143,8,13, "elemental swarm|3825"},
{143,14,19, "energy drain|3825"},
{143,20,25, "etherrealness|3825"},
{143,26,31, "foresight|3825"},
{143,32,37, "gate|8825"},
{143,38,46, "heal, mass|3825"},
{143,47,53, "implosion|3825"},
{143,54,55, "miracle|28825"},
{143,56,61, "regenerate|3825"},
{143,62,66, "shambler|3825"},
{143,67,72, "shapechanger|3825"},
{143,73,77, "sould bind|3825"},
{143,78,83, "storm of vengeance|3825"},
{143,84,89, "summon monster IX|3825"},
{143,90,95, "summan natures ally IX|3825"},
{143,96,99, "sympathy|5325"},
{143,100,100, "true resurrection|28825"},
{146,1,15, "Charming|16500|8"},
{146,16,30, "Fire|17750|8"},
{146,31,40, "Swarming insects|24750|9"},
{146,41,60, "Healing|27750|8"},
{146,61,75, "Size alteration|29000|8"},
{146,76,90, "Illumination|48250|15"},
{146,91,95, "Frost|56250|10"},
{146,96,100, "Defense|58250|15"},
{145,1,3, "Charming|16500|8"},
{145,4,9, "Fire|17750|8"},
{145,10,11, "Swarming insects|24750|9"},
{145,12,17, "Healing|27750|8"},
{145,18,19, "Size alteration|29000|8"},
{145,20,24, "Illumination|48250|15"},
{145,25,31, "Frost|56250|10"},
{145,32,38, "Defense|58250|15"},
{145,39,43, "Abjuration|65000|13"},
{145,44,48, "Conjuration|65000|13"},
{145,49,53, "Enchantment|65000|13"},
{145,54,58, "Evocation|65000|13"},
{145,59,63, "Illusion|65000|13"},
{145,64,68, "Necromancy|65000|13"},
{145,69,73, "Transmutation|65000|13"},
{145,74,77, "Divination|73500|13"},
{145,78,82, "Earth and Stone|80500|11"},
{145,83,87, "Woodlands|101250|13"},
{145,88,92, "Life|155750|13"},
{145,93,97, "Passage|170500|17"},
{145,98,100, "Power|211000|15"},
{144,1,85, "wooden"},
{144,86,93, "metal"},
{144,94,97, "bone"},
{144,98,99, "ivory"},
{144,100,100, "glass"},
{149,1,2, "detect magic|375|1"},
{149,3,4, "Light|375|1"},
{149,5,7, "Burning hands|750|1"},
{149,8,10, "Charm animal|750|1"},
{149,11,13, "Charm person|750|1"},
{149,14,16, "Color spray|750|1"},
{149,17,19, "Cure light wounds|750|1"},
{149,20,22, "Detect secret doors|750|1"},
{149,23,25, "Enlarge person|750|1"},
{149,26,28, "Magic Missile|750|1"},
{149,29,31, "Shocking grasp|750|1"},
{149,32,34, "Summon monster I|750|1"},
{149,35,37, "Magic missile|3750|5"},
{149,38,40, "Bears endurance|4500|6"},
{149,41,43, "Bulls strength|4500|6"},
{149,44,46, "Cats grace|4500|6"},
{149,47,49, "Cure moderate wounds|4500|6"},
{149,50,51, "Darkness|4500|6"},
{149,52,54, "Daylight|4500|6"},
{149,55,57, "Delay poison|4500|6"},
{149,58,60, "Eagles splendor|4500|6"},
{149,61,63, "False life|4500|6"},
{149,64,66, "Fox cunning|4500|6"},
{149,67,68, "Ghoul touch|4500|6"},
{149,69,71, "Hold person|4500|6"},
{149,72,74, "Invisibility|4500|6"},
{149,75,77, "Knock|4500|6"},
{149,78,80, "Levitate|4500|6"},
{149,81,83, "Melfs acid arrow|4500|6"},
{149,84,86, "Mirror image|4500|6"},
{149,87,89, "Owls wisdom|4500|6"},
{149,90,91, "Shatter|4500|6"},
{149,92,94, "Silence|4500|6"},
{149,95,97, "Summon monster II|4500|6"},
{149,98,100, "Web|4500|6"},
{148,1,3, "Magic missile|3750|5"},
{148,4,7, "Bears endurance|4500|6"},
{148,8,11, "Bulls strength|4500|6"},
{148,12,15, "Cats grace|4500|6"},
{148,16,20, "Cure moderate wounds|4500|6"},
{148,21,22, "Darkness|4500|6"},
{148,23,24, "Daylight|4500|6"},
{148,25,27, "Delay poison|4500|6"},
{148,28,31, "Eagles splendor|4500|6"},
{148,32,33, "False life|4500|6"},
{148,34,37, "Fox cunning|4500|6"},
{148,38,38, "Ghoul touch|4500|6"},
{148,39,39, "Hold person|4500|6"},
{148,40,42, "Invisibility|4500|6"},
{148,43,44, "Knock|4500|6"},
{148,45,45, "Levitate|4500|6"},
{148,46,47, "Melfs acid arrow|4500|6"},
{148,48,49, "Mirror image|4500|6"},
{148,50,53, "Owls wisdom|4500|6"},
{148,54,54, "Shatter|4500|6"},
{148,55,56, "Silence|4500|6"},
{148,57,57, "Summon monster II|4500|6"},
{148,58,59, "Web|4500|6"},
{148,60,62, "Magic missile|5250|7"},
{148,63,64, "Magic Missile|6750|9"},
{148,65,67, "Call lightning|11250|5"},
{148,68,68, "Charm person, heightened to 3rd level|11250"},
{148,69,70, "Contagion|11250"},
{148,71,74, "Cure serious wounds|11250"},
{148,75,77, "Dispel magic|11250"},
{148,78,81, "Fireball|11250|5"},
{148,82,83, "Keen edge|11250"},
{148,84,87, "Lightning bolt|11250|5"},
{148,88,89, "Major image|11250"},
{148,90,91, "Slow|11250"},
{148,92,94, "Suggestion|11250"},
{148,95,97, "Summon monster III|11250"},
{148,98,98, "Fireball|13500|6"},
{148,99,99, "Lightning bolt|13500|6"},
{148,100,100, "Searing light|13500|6"},
{147,1,2, "Magic missile|5250|7"},
{147,3,5, "Magic Missile|6750|9"},
{147,6,7, "Call lightning|11250|5"},
{147,8,8, "Charm person, heightened to 3rd level|11250"},
{147,9,10, "Contagion|11250"},
{147,11,13, "Cure serious wounds|11250"},
{147,14,15, "Dispel magic|11250"},
{147,16,17, "Fireball|11250|5"},
{147,18,19, "Keen edge|11250"},
{147,20,21, "Lightning bolt|11250|5"},
{147,22,23, "Major image|11250"},
{147,24,25, "Slow|11250"},
{147,26,27, "Suggestion|11250"},
{147,28,29, "Summon monster III|11250"},
{147,30,31, "Fireball|13500|6"},
{147,32,33, "Lightning bolt|13500|6"},
{147,34,35, "Searing light|13500|6"},
{147,36,37, "Call lightning|18000|8"},
{147,38,39, "Fireball|18000|8"},
{147,40,41, "Lightning bolt|18000|8"},
{147,42,45, "Charm monster|21000"},
{147,46,50, "Cure critical wounds|21000"},
{147,51,52, "Dimension anchor|21000"},
{147,53,55, "Fear|21000"},
{147,56,59, "greater Invisibility|21000"},
{147,60,60, "hold Person, heightened to 4th level|21000"},
{147,61,65, "Ice storm|21000"},
{147,66,68, "Inflict critical wounds|21000"},
{147,69,72, "Neutralize poison|21000"},
{147,73,74, "Poison|21000"},
{147,75,77, "Polymorph|21000"},
{147,78,78, "Ray of enfeeblement, heightened to 4th level|21000"},
{147,79,79, "Suggestion, heightened to 4th level|21000"},
{147,80,82, "Summon monster IV|21000"},
{147,83,86, "Wall of fire|21000"},
{147,87,90, "Wall of ice|21000"},
{147,91,91, "Dispel magic|22500|10"},
{147,92,92, "Fireball|22500|10"},
{147,93,93, "Lightning bolt|22500|10"},
{147,94,94, "Chaos hammer|24000|8"},
{147,95,95, "Holy smite|24000|8"},
{147,96,96, "Orders wrath|24000|8"},
{147,97,97, "Unholy blight|24000|8"},
{147,98,99, "Restoration|26000"},
{147,100,100, "Stoneskin|33500"},
{150,1,15, "design indicates wands function"},
{150,16,30, "inscription indicates wands function"},
{150,31,100, "Nothing"},
{151,1,1, "Quaal's feather token, anchor|50"},
{151,2,2, "Universal Solvent|50"},
{151,3,3, "Elixer of Love|150"},
{151,4,4, "Unguent of timelessness|150"},
{151,5,5, "Quaal's feather token, fan|200"},
{151,6,6, "Dust of tracelessness|250"},
{151,7,7, "Elixir of hiding|250"},
{151,8,8, "Elixir of sneaking|250"},
{151,9,9, "Elixir of swimming|250"},
{151,10,10, "Elixir of vision|250"},
{151,11,11, "Silversheen|250"},
{151,12,12, "Quaal's feather token, bird|300"},
{151,13,13, "Quaal's feather token, tree|400"},
{151,14,14, "Quaal's feather token, swan boat|450"},
{151,15,15, "Elixir of truth|500"},
{151,16,16, "Quaal's feather token, whip|500"},
{151,17,17, "Dust of dryness|850"},
{151,18,18, "Bag of tricks, gray|900"},
{151,19,19, "Hand of the mage|900"},
{151,20,20, "Bracers of Armor +1|1000"},
{151,21,21, "Cloak of resistance +1|1000"},
{151,22,22, "Pearl of power, 1st-level spell|1000"},
{151,23,23, "Phylactery of faithfulness|1000"},
{151,24,24, "Salve of slipperiness|1000"},
{151,25,25, "Elixir of fire breath|1100"},
{151,26,26, "Pipes of the sewers|1150"},
{151,27,27, "Dust of illusion|1200"},
{151,28,28, "Goggles of minute seeing|1250"},
{151,29,29, "Brooch of shielding|1500"},
{151,30,30, "Necklace of fireballs type I|1650"},
{151,31,31, "Dust of appearance|1800"},
{151,32,32, "Hat of disguise|1800"},
{151,33,33, "Pipes of sounding|1800"},
{151,34,34, "Quiver of Ehlonna|1800"},
{151,35,35, "Amulet of natural armor +1|2000"},
{151,36,36, "Heward's handy haversack|2000"},
{151,37,37, "Horn of fog|2000"},
{151,38,38, "Elemental gem|2250"},
{151,39,39, "Robe of bones|2400"},
{151,40,40, "Sovereign glue|2400"},
{151,41,41, "Bag of Holding type I|2500"},
{151,42,42, "Boots of elvenkind|2500"},
{151,43,43, "Boots of the winterlands|2500"},
{151,44,44, "Candle of truth|2500"},
{151,45,45, "Cloak of elvenkind|2500"},
{151,46,46, "Eyes of the eagle|2500"},
{151,47,47, "Scarab, golembane|2500"},
{151,48,48, "Necklace of fireballs type II|2700"},
{151,49,49, "Stone of Alarm|2700"},
{151,50,50, "Bag of tricks, rust|3000"},
{151,51,51, "Bead of force|3000"},
{151,52,52, "Chime of opening|3000"},
{151,53,53, "Horseshoes of speed|3000"},
{151,54,54, "Rope of Climbing|3000"},
{151,55,55, "Dust of disappearance|3500"},
{151,56,56, "Lens of detection|3500"},
{151,57,57, "Vestments, druid's|3750"},
{151,58,58, "Figurine of wondrous power, silver raven|3800"},
{151,59,59, "Amulet of health +2|4000"},
{151,60,60, "Bracers of armor +2|4000"},
{151,61,61, "Cloak of charisma +2|4000"},
{151,62,62, "Cloak of resistance +2|4000"},
{151,63,63, "Gauntlets of ogre power|4000"},
{151,64,64, "Gloves of arrow snaring|4000"},
{151,65,65, "Gloves of Dexterity +2|4000"},
{151,66,66, "Headband of intellect +2|4000"},
{151,67,67, "Ioun stone, clear spindle|4000"},
{151,68,68, "Keoghton's ointment|4000"},
{151,69,69, "Nolzur's marvelous pigments|4000"},
{151,70,70, "Pearl of power|x"},
{151,71,71, "Periapt of Wisdom +2|4000"},
{151,72,72, "Stone salve|72"},
{151,73,73, "Necklace of fireballs type III|4350"},
{151,74,74, "Circlet of persuasion|4500"},
{151,75,75, "Slippers of spider climbing|4800"},
{151,76,76, "Incense of meditation|4900"},
{151,77,77, "Bag of holding type II|5000"},
{151,78,78, "Bracers of archery, lesser|5000"},
{151,79,79, "Iuon stone, dusty rose prism|5000"},
{151,80,80, "Helm of comprehand languages and read magic|5200"},
{151,81,81, "Vest of escape|5200"},
{151,82,82, "Eversmoking bottle|5400"},
{151,83,83, "Murland's Spoon|5400"},
{151,84,84, "Necklace of fireballs type IV|5400"},
{151,85,85, "Boots of striding and springing|5500"},
{151,86,86, "Wind fan|5500"},
{151,87,87, "Amulet of mighty fists +1|6000"},
{151,88,88, "Horseshoes of a zephyr|6000"},
{151,89,89, "Pipes of haunting|6000"},
{151,90,90, "Necklace of fireballs type V|6150"},
{151,91,91, "Gloves of swimming and climbing|6250"},
{151,92,92, "Bag of tricks, tan|6300"},
{151,93,93, "Circlet of blasting, minor|6480"},
{151,94,94, "Horn of goodnes|6500"},
{151,95,95, "Robe of useful items|7000"},
{151,96,96, "Boat, folding|7200"},
{151,97,97, "Cloak of the manta ray|7200"},
{151,98,98, "Bottle of air|7250"},
{151,99,99, "Bag of Holding type III|7400"},
{151,100,100, "Periapt of healt|7400"},
{152,1,1, "Boots of levitation|7500"},
{152,2,2, "Harp of charming|7500"},
{152,3,3, "Amulet of natural armor +2|8000"},
{152,4,4, "Golem manual, flesh|8000"},
{152,5,5, "Hand of glory|8000"},
{152,6,6, "Ioun stone, deep red sphere|8000"},
{152,7,7, "Ioun stone, incandescent blue sphere|8000"},
{152,8,8, "Ioun stone, pale bule rhomboid|8000"},
{152,9,9, "Ioun stone, pink and green sphere|8000"},
{152,10,10, "Ioun stone, pink rhomboid|8000"},
{152,11,11, "Ioun stone, scarlet and blue sphere|8000"},
{152,12,12, "Deck of illusions|8100"},
{152,13,13, "Necklace of fireballs type VI|8100"},
{152,14,14, "Candle of invocation|8400"},
{152,15,15, "Bracers of armor +3|9000"},
{152,16,16, "Cloak of resistance +3|9000"},
{152,17,17, "Decanter of endless water|9000"},
{152,18,18, "Necklace of adaptation|9000"},
{152,19,19, "Pearl of power, 3rd-level spell|9000"},
{152,20,20, "Talisman of the sphere|9000"},
{152,21,21, "Figurine of wondrous power, serpentine owl|9100"},
{152,22,22, "Necklace of fireballs type VII|9000"},
{152,23,23, "Strand of prayer beads, lesser|9600"},
{152,24,24, "Bag of holding type IV|10000"},
{152,25,25, "Figurine of wondrous power, bronze griffon|10000"},
{152,26,26, "Figurine of wondrous power, ebony fly|10000"},
{152,27,27, "Gloves of storing|10000"},
{152,28,28, "Ioun stone, dark blue rhomboid|10000"},
{152,29,29, "Stone horse, courser|10000"},
{152,30,30, "Cape of the mountebank|10080"},
{152,31,31, "Phylactery of undead turning|11000"},
{152,32,32, "Gauntlet of rust|11500"},
{152,33,33, "Boots of speed|12000"},
{152,34,34, "Goggles of night|12000"},
{152,35,35, "Golem manual, clay|12000"},
{152,36,36, "Medallion of thoughts|12000"},
{152,37,37, "Pipes of pain|12000"},
{152,38,38, "Boccob's blessed book|12500"},
{152,39,39, "Belt, monk's|13000"},
{152,40,40, "Gem of brightness|13000"},
{152,41,41, "Lyre of building|13000"},
{152,42,42, "Cloak of arachnida|14000"},
{152,43,43, "Stone horse, destrier|14800"},
{152,44,44, "Belt of dwarvenkind|14900"},
{152,45,45, "Periphat of wound closure|15000"},
{152,46,46, "Horn of the tritons|15100"},
{152,47,48, "Figureine of wondrous power, onyx dog|15500"},
{152,49,49, "Amulet of health +4|16000"},
{152,50,50, "Belt of giant Strenght +4|16000"},
{152,51,51, "Boots, winged|16000"},
{152,52,52, "Bracers of armor +4|16000"},
{152,53,53, "Cloak of Charisma +4|16000"},
{152,54,54, "Cloak of resistance +4|16000"},
{152,55,55, "Gloves of Dexterity +4|16000"},
{152,56,56, "Headband of intellect +4|16000"},
{152,57,57, "Pearl of power, 4th-level spell|16000"},
{152,58,58, "Periapt of Wisdom +4|16000"},
{152,59,59, "Scabbard of keen edges|16000"},
{152,60,60, "Figurine of wondrous power, golden lions|16500"},
{152,61,61, "Chime of interruption|16800"},
{152,62,62, "Broom of flying|17000"},
{152,63,63, "Figuring of wondrous power, marble elephant|17000"},
{152,64,64, "Amulet of natural armor +3|18000"},
{152,65,65, "Ioun stone, iridescent spindle|18000"},
{152,66,66, "Bracelet of friends|19000"},
{152,67,67, "Carpet of flying, 5 ft. by 5 ft.|20000"},
{152,68,68, "Horn of blasting|20000"},
{152,69,69, "Ioun stone, pale lavender ellipsoid|20000"},
{152,70,70, "Ioun stone, pearly white spindle|20000"},
{152,71,71, "Portable hole|20000"},
{152,72,72, "Stone of good luck (luckstone)|20000"},
{152,73,73, "Figurine of wondrous power, ivory goats|21000"},
{152,74,74, "Rope of entanglement|21000"},
{152,75,75, "Golem manual, stone|22000"},
{152,76,76, "Mask of the skull|22000"},
{152,77,77, "Mattock of the titans|23348"},
{152,78,78, "Circlet of blasting, minor|23760"},
{152,79,79, "Amulet of mighty fists +2|24000"},
{152,80,80, "Cloak of displacement, minor|24000"},
{152,81,81, "Helm of underwater action|24000"},
{152,82,82, "Bracers of archery, greater|25000"},
{152,83,83, "Bracers of armor +5|25000"},
{152,84,84, "Cloak of resistance +5|25000"},
{152,85,85, "Eyes of doom|25000"},
{152,86,86, "Pearl of power, 5th-level spell|25000"},
{152,87,87, "Maul of the titans|25305"},
{152,88,88, "Strand of prayer beads|25800"},
{152,89,89, "Claok of the bat|26000"},
{152,90,90, "Iron bands of Bilarro|26000"},
{152,91,91, "Cube of frost resistance|27000"},
{152,92,92, "Helm of telepathy|27000"},
{152,93,93, "Periapt of proof against poison|27000"},
{152,94,94, "Robe of scintillating coloros|27000"},
{152,95,95, "Manual of bodily health +1|27500"},
{152,96,96, "Manual of gainful exercise +1|27500"},
{152,97,97, "Manual of quickness in action +1|27500"},
{152,98,98, "Tome of clear thought +1|27500"},
{152,99,99, "Tome of leadership and influence +1|27500"},
{152,100,100, "Tome of clear thought +1|27500"},
{153,1,1, "Dimensional Shackles|28000"},
{153,2,2, "Figurine of wondrous power, obsidian steed|28500"},
{153,3,3, "Drums of Panic|30000"},
{153,4,4, "Ioun stone, orange|30000"},
{153,5,5, "Ioun stone, pale green prism|30000"},
{153,6,6, "Latern of revealing|30000"},
{153,7,7, "Robe of blending|30000"},
{153,8,8, "Amulet of natural armor +4|32000"},
{153,9,9, "Amulet of proof against detection and location|35000"},
{153,10,10, "Carpet of Flying, 5ft by 10 ft.|35000"},
{153,11,11, "Golem manual, iron|35000"},
{153,12,12, "Amulet of health +6|36000"},
{153,13,13, "Belt of giant Strength +6|36000"},
{153,14,14, "Bracers of armor +6|36000"},
{153,15,15, "Cloak of Charisma +6|36000"},
{153,16,16, "Gloves of Dexiterity +6|36000"},
{153,17,17, "Headband of intellect +6|36000"},
{153,18,18, "Ioun stone, vibrant puple prism|36000"},
{153,19,19, "Pearl of power, 6th-level spell|36000"},
{153,20,20, "Periapt of Wisdom +6|36000"},
{153,21,21, "Scarab of protection|38000"},
{153,22,22, "Ioun stone, lavender and green ellipsoid|40000"},
{153,23,23, "Ring gates|40000"},
{153,24,24, "Crystal ball|42000"},
{153,25,25, "Golem manual, greater stone|44000"},
{153,26,26, "Orb of storms|48000"},
{153,27,27, "Boots of teleportation|49000"},
{153,28,28, "Bracers of armor +7|49000"},
{153,29,29, "Pearl of power, 7th-level spell|49000"},
{153,30,30, "Amulet of natural armor +5|50000"},
{153,31,31, "Cloak of displacement, major|50000"},
{153,32,32, "Crystal ball with see invisibility|50000"},
{153,33,33, "Horn of Valhalla|50000"},
{153,34,34, "Crystal ball with detect thoughts|51000"},
{153,35,35, "Carpet of flying, 6 ft. by 9 ft.|53000"},
{153,36,36, "Amulet of mighty fists +3|54000"},
{153,37,37, "Wings of flying|54000"},
{153,38,38, "Cloak of etheralness|55000"},
{153,39,39, "Daern's instant fortress|55000"},
{153,40,40, "Manual of bodily health +2|55000"},
{153,41,41, "Manual of gainful exercise +2|55000"},
{153,42,42, "Manual of quickness in action +2|55000"},
{153,43,43, "Tome of clear thought +2|55000"},
{153,44,44, "Tome of leadership and influence +2|55000"},
{153,45,45, "Tome of undetstanding +2|55000"},
{153,46,46, "Eyes of Charming|56000"},
{153,47,47, "Robe of stars|58000"},
{153,48,48, "Carpet of flying, 10 ft. by 10 ft.|60000"},
{153,49,49, "Darkskull|60000"},
{153,50,50, "Cube of force|62000"},
{153,51,51, "Bracers of armor +8|64000"},
{153,52,52, "Pearl of power, 8th-level spell|64000"},
{153,53,53, "Crystal ball with telepathy|70000"},
{153,54,54, "Horn of blasting, greater|70000"},
{153,55,55, "Pearl of power, two spells|70000"},
{153,56,56, "Helm of teleportation|73500"},
{153,57,57, "Gem of seeing|75000"},
{153,58,58, "Robe of the archmagi|75000"},
{153,59,59, "Mantle of faith|76000"},
{153,60,60, "Crystal ball with true seeing|80000"},
{153,61,61, "Pearl of power, 9th-level spell|81000"},
{153,62,62, "Well of many worlds|82000"},
{153,63,63, "Manual of bodily health +3|82500"},
{153,64,64, "Manual of gainful exercise +3|82500"},
{153,65,65, "Manual of quickness in action +3|82500"},
{153,66,66, "Tome of clear thought +3|82500"},
{153,67,67, "Tome of leadership and influence +3|82500"},
{153,68,68, "Tome of understanding +3|82500"},
{153,69,69, "Apparatus of Kwalish|90000"},
{153,70,70, "Mantle of spell resistance|90000"},
{153,71,71, "Mirror of opposition|92000"},
{153,72,72, "Strand of prayer beads, greater|95800"},
{153,73,73, "Amulet of mighty fists +4|96000"},
{153,74,74, "Eyes of petrification|98000"},
{153,75,75, "Bowl of commanding water elementals|100000"},
{153,76,76, "Braizer of commanding fire elementals|100000"},
{153,77,77, "Censer of controlling air elementals|100000"},
{153,78,78, "Stone of controlling earth elementals|100000"},
{153,79,79, "Manual of bodily health +4|110000"},
{153,80,80, "Manual of gainful exercise +4|110000"},
{153,81,81, "Manual of quickness in action +4|110000"},
{153,82,82, "Tome of clear thought +4|110000"},
{153,83,83, "Tome of leadership and influence +4|110000"},
{153,84,84, "Tome of understanding +4|110000"},
{153,85,85, "Amulet of the planes|120000"},
{153,86,86, "Robe of eyes|120000"},
{153,87,87, "Helm of brilliance|125000"},
{153,88,88, "Manual of bodily health +5|137500"},
{153,89,89, "Manual of gainful exercise +5|137500"},
{153,90,90, "Manual of quickness in action +5|137500"},
{153,91,91, "Tome of clear thought +5|137500"},
{153,92,92, "Tome of leadership and influence +5|137500"},
{153,93,93, "Tome of understanding +5|137500"},
{153,94,94, "Efreeti bottle|145000"},
{153,95,95, "Amulet of mighty fists +5|150000"},
{153,96,96, "Chaos diamond|160000"},
{153,97,97, "Cubic gate|164000"},
{153,98,98, "Iron flask|170000"},
{153,99,99, "Mirror of mental prowess|175000"},
{153,100,100, "Mirror of life trapping|200000"},
{3,1,30, "small"},
{3,31,90, "normal"},
{3,91,100, "(size: DM's choice)"},
{1,1,25, "good"},
{1,26,50, "evil"},
{1,51,75, "lawful"},
{1,76,100, "chaotic"},
{2,1,50, "same"},
{2,51,100, "less"},

{255,1,1, "none"}};

// ********************************************************************************
extern int getRND(int );
extern int parseDice(char *);

// ********************************************************************************
int findTreasureLine(int tbl, int roll) {
	int i;

//printf("fTL: %d %d\n", tbl, roll);
	i = -1;
	while (rndTreasureTblData[++i].table_id != 255) {
//if (config.flags.f_debug != 0) { printf("gRT: %d:%d\n", tbl, rndTreasureTblData[i].table_id); }
		if (rndTreasureTblData[i].table_id == tbl) {
// printf("fTL: %d %d %s\n", tbl, roll, rndTreasureTblData[i].data);
			if (roll >= rndTreasureTblData[i].start_roll && roll <= rndTreasureTblData[i].end_roll) {
				return(i);
			}
			if (rndTreasureTblData[i].start_roll > roll) {
				return(i-1);
			}
		}
	}
	return (-1);
}

// ********************************************************************************
void parseTreasureData(int line, int lvl, Fl_Text_Display *br) {
	char *token[15], data[100], strng[100], spaces[] = {"                   "}, buf[100];
	int tbl, dice=1, i, prevtoken=0, tkn=1;

	strcpy(data, rndTreasureTblData[line].data);
	token[0] = strtok(data, "|");
	while ((token[tkn] = strtok(NULL, "|")) != NULL && tkn < 15) {
		tkn++;
	}
	token[tkn] = NULL;
	tkn = 0;
	buf[0] = '\0';

	do {
//printf("Token = %s\n", token[tkn]);
		token[14] = strchr(token[tkn], 'd');
		if (strcmp(token[tkn], "cp") == 0 || strcmp(token[tkn], "sp") == 0 || strcmp(token[tkn], "gp") == 0 || strcmp(token[tkn], "pp") == 0) {
			tkn++;		// a dice string
			if ((token[13] = strstr(token[tkn], "x")) != NULL) {
				*token[13] = '\0';
				dice = parseDice(token[tkn]) * atoi(token[13]+1);
			} else {
				dice = parseDice(token[tkn]);
			}
			spaces[lvl] = '\0';
			sprintf(buf, "%s%d %s", spaces, dice, token[tkn-1]);
			br->buffer()->append(buf); br->buffer()->append("\n");
			spaces[lvl] = ' ';
			dice = 1;
			buf[0] = '\0';
			prevtoken=1;
		} else if (strncmp(token[tkn], "t#", 2) == 0) {		// found a table pointer token
			tbl = atoi(&token[tkn][2]);
//printf("Table Token = %s %d:%d %s\n", token[0], tbl, dice, token[4]);
			if (tbl > 0 && tbl < 175) {
				if (prevtoken != 3) {
					spaces[lvl] = '\0';
					sprintf(strng, "%s%s", spaces, buf);
					if (strstr(buf, "arcane") == NULL && strstr(buf, "divine") == NULL && strlen(buf) > 1) {
						br->buffer()->append(strng); br->buffer()->append("\n");
					}
					spaces[lvl] = ' ';
				}
				for (int j = 0; j<dice; j++) {
					if ((i = findTreasureLine(tbl, getRND(100))) != -1) {
						parseTreasureData(i, lvl+2, br);
					}
				}
			}
//printf("1: %s\n", buf);
			buf[0] = '\0';
			prevtoken=2;
		} else if (token[14] != NULL && isdigit(*(token[14]-1)) && isdigit(*(token[14]+1))) {	// found a dice string
//printf("Dice Token = %s", token[0]);
			dice = 1;
			if (tbl < 64 || tbl > 71) {		// handle Gems and Art-work differently
				if ((token[14] = strstr(token[tkn], "x")) != NULL) {
					*token[14] = '\0';
					dice = parseDice(token[tkn]);
					sprintf(buf, "%d x%s", dice, ++token[14]);
				} else {
					strcat(buf, token[tkn]);
				}
				strcat(buf, "gp ");
			} else {
				if ((token[14] = strstr(token[tkn], "x")) != NULL) {
					*token[14] = '\0';
					dice = parseDice(token[tkn]) * atoi(token[14]+1);
				} else {
					dice = parseDice(token[tkn]);
				}
			}
//printf(" (%d) %s\n", dice, buf);
			prevtoken=3;
		} else {
			sprintf(strng, "%s ", token[tkn]);
			strcat(buf, strng);
			prevtoken=4;
		}
//		token[4] = token[0];		// make a backup just incase
	} while (token[++tkn] != NULL);
//printf("Token = %s Lvl = %d\n", token[0], lvl);

	if (strlen(buf) > 1) {		// print the final description string
		spaces[lvl] = '\0';
		sprintf(strng, "%s%s", spaces, buf);
		if (strstr(buf, "arcane") == NULL && strstr(buf, "divine") == NULL && strlen(buf) > 1) {
			br->buffer()->append(strng); br->buffer()->append("\n");
		}
//printf("2: %s\n", buf);
	}
}

// ********************************************************************************
void generateRndTreasure() {
	int i, rnd;
	int el, goods, money, items;

	el = (int )aRT_ELLevel->value() - 1;
	goods = 100; //(int )aRT_Goods->value();
	money = 100; //(int )aRT_Money->value();
	items = 100; //(int )aRT_Items->value();
//if (config.flags.f_debug != 0) { printf("gRT: %d:%d:%d:%d\n", el, money, goods, items); }

	treasure_buffer[0]->select(0, treasure_buffer[0]->length());
	treasure_buffer[0]->remove_selection();


rnd = getRND(100);
printf("\nMoney: %d\n", rnd);
	if ((i = findTreasureLine(rndTreasureTbl[el][1], rnd)) != -1) {
		aRT_Treasure->buffer()->append("   Money:\n");
		parseTreasureData(i, 0, aRT_Treasure);
		aRT_Treasure->buffer()->append("\n");
	} else {
		printf("Unable to find Money Line\n");
	}

rnd = getRND(100);
printf("\nGoods: %d\n", rnd);
	if ((i = findTreasureLine(rndTreasureTbl[el][2], rnd)) != -1) {
		aRT_Treasure->buffer()->append("   Goods:\n");
		parseTreasureData(i, 0, aRT_Treasure);
		aRT_Treasure->buffer()->append("\n"); 
	} else {
		printf("Unable to find Goods Line\n");
	}

rnd = getRND(100);
printf("\nItems: %d\n", rnd);
//	if ((i = findTreasureLine(162,100)) != -1) {
	if ((i = findTreasureLine(rndTreasureTbl[el][3], rnd)) != -1) {
		aRT_Treasure->buffer()->append("   Items:\n");
		parseTreasureData(i, 0, aRT_Treasure);
		aRT_Treasure->buffer()->append("\n");
	} else {
		printf("Unable to find Items Line\n");
	}
}
